SystemOrganization addCategory: #'Seaside-Canvas'!
SystemOrganization addCategory: #'Seaside-Canvas-Tags'!

!GRPackage class methodsFor: '*seaside-canvas' stamp: 'lr 2/17/2010 15:12'!
seasideCanvas
	^ self new
		name: 'Seaside-Canvas';
		description: 'The mechanism of choice to generate valid and reusable XHTML markup.';
		addDependency: 'Seaside-Core';
		url: #seasideUrl;
		yourself
! !

WARenderer subclass: #WACanvas
	instanceVariableNames: 'currentBrush parentBrush'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WACanvas commentStamp: 'pmm 2/18/2011 23:04' prior: 0!
This is the superclass of all canvas. It's a rendering interface that generates brushes (see WABrush).

Subclass WAXmlCanvas, if you want to generate an XML dialect.!

!WACanvas methodsFor: 'public' stamp: 'avi 6/17/2004 12:36'!
brush: aBrush
	self flush.
	currentBrush := aBrush.
	aBrush setParent: parentBrush canvas: self.
	^ aBrush! !

!WACanvas methodsFor: 'private' stamp: 'lr 2/28/2009 22:40'!
flush
	super flush.
	currentBrush isNil
		ifTrue: [ ^ self ].
	currentBrush close.
	currentBrush := nil! !

!WACanvas methodsFor: 'private' stamp: 'lr 6/6/2007 10:32'!
insert: aBlock
	| oldBrush |
	oldBrush := currentBrush.
	currentBrush := nil.
	aBlock value.
	self flush.
	currentBrush := oldBrush! !

!WACanvas methodsFor: 'private' stamp: 'jf 11/4/2008 12:41'!
nest: aBlock
	parentBrush := currentBrush.
	currentBrush := nil.
	self render: aBlock.
	self flush.
	parentBrush := parentBrush parent! !

!WACanvas methodsFor: 'public' stamp: 'jf 10/19/2008 01:57'!
render: anObject
	self flush.
	super render: anObject! !

!WACanvas methodsFor: 'public' stamp: 'jf 10/19/2008 01:56'!
text: anObject
	self flush.
	super text: anObject! !

WACanvas subclass: #WATagCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

WATagCanvas subclass: #WAHtmlCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WAHtmlCanvas commentStamp: 'pmm 2/8/2011 07:10' prior: 0!
I'm a canvas fro building HTML.!

!WAHtmlCanvas class methodsFor: 'instance creation' stamp: 'jf 2/15/2009 21:00'!
builder
	^ super builder
			rootClass: WAHtmlRoot;
			documentClass: WAHtmlDocument;
			yourself! !

!WAHtmlCanvas class methodsFor: 'class initialization' stamp: 'pmm 9/28/2011 18:59'!
initialize
	self selectAsDefault! !

!WAHtmlCanvas class methodsFor: 'class initialization' stamp: 'pmm 9/28/2011 18:59'!
unload
	self unselectAsDefault! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 4/9/2007 17:01'!
abbreviated
	"Defines an abbreviation, such as 'M.', 'Inc.', 'et al.', 'etc.'"

	^ self tag: 'abbr'! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'pmm 9/30/2006 20:06'!
abbreviated: aBlock
	self abbreviated with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 10/28/2007 14:42'!
acronym
	"Defines an acronym, such as 'GmbH', 'NATO', and 'F.B.I.'"

	^ self tag: 'acronym'! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'mb 3/24/2006 13:42'!
acronym: aBlock
	self acronym with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 10/28/2007 14:42'!
address
	"Defines an address element."

	^ self tag: 'address'! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'pmm 12/24/2005 17:44'!
address: aBlock
	self address with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 10/28/2007 14:42'!
anchor
	"Defines an anchor."

	^ self brush: WAAnchorTag new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 4/9/2007 17:23'!
anchor: aBlock
	self anchor with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 7/29/2007 10:54'!
article
	"The article element represents a section of a page that consists of a composition that forms an independent part of a document, page, or site. This could be a forum post, a magazine or newspaper article, a Web log entry, a user-submitted comment, or any other independent item of content.

	An article element is 'independent' in that its contents could stand alone, for example in syndication. However, the element is still associated with its ancestors; for instance, contact information that applies to a parent body element still covers the article as well.

	When article elements are nested, the inner article elements represent articles that are in principle related to the contents of the outer article. For instance, a Web log entry on a site that accepts user-submitted comments could represent the comments as article elements nested within the article element for the Web log entry.

	Author information associated with an article element (q.v. the address element) does not apply to nested article elements.

	Each article element potentially has a heading."
	^ self tag: 'article'! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 7/29/2007 10:54'!
article: aBlock
	self article with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 7/29/2007 10:42'!
aside
	"The aside element represents a section of a page that consists of content that is tangentially related to the content around the aside element, and which could be considered separate from that content. Such sections are often represented as sidebars in printed typography.

	When used as an inline-level content container, the element represents a paragraph.

	Each aside element potentially has a heading. "
	^ self tag: 'aside'! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 7/29/2007 10:42'!
aside: aBlock
	self aside with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'as 2/1/2011 18:11'!
audio
	"An audio element represents a sound or audio stream."
	^ self brush: WAAudioTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'as 1/30/2011 05:41'!
audio: aBlock
	self audio with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'jf 2/21/2009 11:08'!
basicForm
	^ self brush: WABasicFormTag new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'pmm 8/1/2010 14:10'!
basicForm: aBlock
	self basicForm with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 2/2/2011 19:42'!
bidirectional
	"The bdi element represents a span of text that is to be isolated from its surroundings for the purposes of bidirectional text formatting."
	^ self tag: 'bdi'! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 2/2/2011 19:43'!
bidirectional: aBlock
	self bidirectional with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 9/28/2011 19:59'!
bidirectionalOverride
	"The bdo element represents explicit text directionality formatting control for its children. It allows authors to override the Unicode bidirectional algorithm by explicitly specifying a direction override. [BIDI]

Authors must specify the dir attribute on this element, with the value ltr to specify a left-to-right override and with the value rtl to specify a right-to-left override."
	^ self tag: 'bdo'! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 9/28/2011 19:59'!
bidirectionalOverride: aBlock
	self bidirectionalOverride with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 10/28/2007 14:42'!
big
	"Defines big text."

	^ self tag: 'big'! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'ac 2/21/2006 14:36'!
big: aBlock
	self big with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 4/9/2007 17:02'!
blockquote
	"Defines a long quotation."

	^ self tag: 'blockquote'! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'avi 6/3/2005 15:40'!
blockquote: aBlock
	self blockquote with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'lr 10/28/2007 14:42'!
break
	"Inserts a single line break."

	^ self brush: WABreakTag new! !

!WAHtmlCanvas methodsFor: 'form-buttons' stamp: 'as 2/6/2011 22:01'!
button
	^ self brush: WAButtonTag new! !

!WAHtmlCanvas methodsFor: 'form-buttons' stamp: 'as 2/6/2011 22:01'!
button: anObject
	^ self button with: anObject! !

!WAHtmlCanvas methodsFor: 'form-buttons' stamp: 'as 2/6/2011 22:01'!
cancelButton
	^ self brush: WACancelButtonTag new! !

!WAHtmlCanvas methodsFor: 'form-buttons' stamp: 'as 2/6/2011 22:01'!
cancelButton: anObject
	^ self cancelButton with: anObject! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'lr 5/18/2006 08:55'!
canvas
	^ self brush: WACanvasTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'mb 11/30/2006 16:29'!
canvas: aBlock
	self canvas with: aBlock! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
checkbox
	^ self brush: WACheckboxTag new! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 10/28/2007 14:42'!
citation
	"Defines a citation."

	^ self tag: 'cite'! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'pmm 9/30/2006 20:06'!
citation: aBlock
	self citation with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
code
	"Defines computer code text."

	^ self tag: 'code'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'avi 6/3/2005 15:40'!
code: aBlock
	self code with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'as 2/6/2011 21:58'!
colorInput
	^ self brush: WAColorInputTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 8/8/2007 22:08'!
command
	^ self brush: WACommandTag new	! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 8/8/2007 22:08'!
command: aBlock
	self command with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'as 2/6/2011 21:59'!
datalist
	^ self brush: WADatalistTag new	! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'as 2/6/2011 21:59'!
datalist: aBlock
	self datalist with: aBlock! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
dateInput
	^ self brush: WADateInput new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'as 2/6/2011 21:59'!
dateInput5
	^ self brush: WADateInputTag new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'as 2/6/2011 21:59'!
dateTimeInput
	^ self brush: WADateTimeInputTag new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'as 2/6/2011 21:59'!
dateTimeLocalInput
	^ self brush: WADateTimeLocalInputTag new! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
definition
	"Defines a definition term."

	^ self tag: 'dfn'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'pmm 9/30/2006 20:06'!
definition: aBlock
	self definition with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 10/28/2007 14:42'!
definitionData
	"Defines a definition description."

	^ self tag: 'dd'! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'pmm 5/31/2006 20:26'!
definitionData: aBlock
	self definitionData with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 10/28/2007 14:42'!
definitionList
	"Defines a definition list."

	^ self tag: 'dl'! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'pmm 12/24/2005 17:42'!
definitionList: aBlock
	self definitionList with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 10/28/2007 14:42'!
definitionTerm
	"Defines a definition term."

	^ self tag: 'dt'! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'pmm 12/24/2005 17:42'!
definitionTerm: aBlock
	self definitionTerm with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 10/28/2007 14:42'!
deleted
	"Defines deleted text."

	^ self brush: (WAEditTag tag: 'del')! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'pmm 3/28/2007 10:42'!
deleted: aBlock
	self deleted with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 7/29/2007 10:40'!
details
	^ self brush: WADetailsTag new	! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 7/29/2007 10:40'!
details: aBlock
	self details with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-styles' stamp: 'lr 10/28/2007 14:42'!
div
	"Defines a section in a document."

	^ self brush: WADivTag new! !

!WAHtmlCanvas methodsFor: 'tags-styles' stamp: 'avi 6/3/2005 15:40'!
div: aBlock
	self div with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'as 2/6/2011 22:00'!
emailInput
	^ self brush: WAEmailInputTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'as 2/1/2011 18:10'!
embed
	"The embed element represents an integration point for an external (typically non-HTML) application or interactive content."
	^ self brush: WAEmbedTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'as 2/1/2011 17:04'!
embed: aBlock
	self embed with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 4/9/2007 16:53'!
emphasis
	"Defines emphasized text."

	^ self tag: 'em'! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'mb 3/8/2006 17:14'!
emphasis: aBlock
	self emphasis with: aBlock! !

!WAHtmlCanvas methodsFor: 'convenience' stamp: 'jf 9/30/2009 01:10'!
encodeCharacter: aCharacter 
	self html: '&#' , aCharacter greaseInteger greaseString , ';'! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 10/28/2007 14:42'!
fieldSet
	"Defines a fieldset."

	^ self brush: WAFieldSetTag new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'mb 3/24/2006 13:45'!
fieldSet: aBlock
	self fieldSet with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 3/18/2007 13:26'!
figure
	"no known browser support
	
	The figure element represents a paragraph consisting of embedded content and a caption.

The first embedded content element child of the figure element, if any, is the paragraph's content.

The first legend element child of the element, if any, represents the caption of the embedded content. If there is no child legend element, then there is no caption. 

	e.g.:
	html figure: [
		html legend: 'Credit: Media Inc., 2007'.
		html image url: 'smith.jpg'; altText: 'Photo: J. Smith' ]"
	^ self tag: 'figure'! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 3/18/2007 13:25'!
figure: aBlock
	self figure with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 2/2/2011 19:44'!
figureCaption
	"The figcaption element represents a caption or legend for the rest of the contents of the figcaption element's parent figure element, if any."
	^ self tag: 'figcaption'! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 2/2/2011 19:44'!
figureCaption: aBlock
	self figureCaption with: aBlock! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
fileUpload
	^ self brush: WAFileUploadTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 1/24/2012 07:20'!
footer
	"The footer element represents the footer for the section it applies to. A footer typically contains information about its section such as who wrote it, links to related documents, copyright data, and the like.

	footer elements must not contain any footer, header, h1, h2, h3, h4, h5, or h6 elements, or any of the sectioning elements (such as section), as descendants.

	When used as an inline-level content container, the element represents a paragraph.

	Contact information for the section given in a footer should be marked up using the address element."
	^ self tag: 'footer'! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 7/29/2007 10:40'!
footer: aBlock
	self footer with: aBlock! !

!WAHtmlCanvas methodsFor: 'form' stamp: 'as 2/6/2011 22:01'!
form
	^ self brush: WAFormTag new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'avi 6/3/2005 15:40'!
form: aBlock
	self form with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 1/24/2012 07:19'!
header
	"The header element represents the header of a section. Headers may contain more than just the section's heading \u2014 for example it would be reasonable for the header to include version history information.

	header elements must not contain any header elements, footer elements, or any sectioning elements (such as section) as descendants.

	header elements must have at least one h1, h2, h3, h4, h5, or h6 element as a descendant. "
	^ self tag: 'header'! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 7/29/2007 10:40'!
header: aBlock
	self header with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'lr 10/28/2007 14:42'!
heading
	"Defines header 1 to header 6."

	^ self brush: WAHeadingTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'ac 3/16/2005 14:14'!
heading: aBlock
	self heading with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 2/2/2011 19:45'!
headingGroup
	"The hgroup element represents the heading of a section. The element is used to group a set of h1-h6 elements when the heading has multiple levels, such as subheadings, alternative titles, or taglines.

	For the purposes of document summaries, outlines, and the like, the text of hgroup elements is defined to be the text of the highest ranked h1-h6 element descendant of the hgroup element, if there are any such elements, and the first such element if there are multiple elements with that rank. If there are no such elements, then the text of the hgroup element is the empty string.

	The rank of an hgroup element is the rank of the highest-ranked h1-h6 element descendant of the hgroup element, if there are any such elements, or otherwise the same as for an h1 element (the highest rank)."
	^ self tag: 'hgroup'! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 2/2/2011 19:45'!
headingGroup: aBlock
	self headingGroup with: aBlock! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
hiddenInput
	^ self brush: WAHiddenInputTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'lr 10/28/2007 14:42'!
horizontalRule
	"Defines a horizontal rule."

	^ self brush: WAHorizontalRuleTag new! !

!WAHtmlCanvas methodsFor: 'public' stamp: 'jf 9/30/2009 01:10'!
html: aString 
	"Emit aString unescaped onto the target document."
	self flush.
	self document nextPutAll: aString greaseString! !

!WAHtmlCanvas methodsFor: 'tags-transitional' stamp: 'pmm 1/3/2008 16:59'!
iframe
	^ self brush: WAIframeTag new! !

!WAHtmlCanvas methodsFor: 'tags-images' stamp: 'lr 10/28/2007 14:42'!
image
	"Defines an image."

	^ self brush: WAImageTag new! !

!WAHtmlCanvas methodsFor: 'tags-images' stamp: 'mb 3/24/2006 13:51'!
image: aBlock
	self image with: aBlock! !

!WAHtmlCanvas methodsFor: 'form-buttons' stamp: 'as 2/6/2011 22:01'!
imageButton
	^ self brush: WAImageButtonTag new! !

!WAHtmlCanvas methodsFor: 'form-buttons' stamp: 'as 2/6/2011 22:01'!
imageButton: anObject
	^ self imageButton with: anObject! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 4/9/2007 17:02'!
inserted
	"Defines inserted text."

	^ self brush: (WAEditTag tag: 'ins')! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'pmm 3/28/2007 10:41'!
inserted: aBlock
	self inserted with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'as 2/6/2011 22:00'!
keyGenerator
	^ self brush: WAKeyGeneratorTag new! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
keyboard
	"Defines keyboard text."

	^ self tag: 'kbd'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 4/9/2007 17:23'!
keyboard: aBlock
	self keyboard with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 10/28/2007 14:42'!
label
	"Defines a label for a form control."

	^ self brush: WALabelTag new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'avi 6/3/2005 15:40'!
label: aBlock
	self label with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 10/28/2007 14:42'!
legend
	"Defines a title in a fieldset."

	^ self tag: 'legend'! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'mb 3/8/2006 18:00'!
legend: aBlock
	self legend with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 2/2/2011 19:48'!
lineBreakOpportunity
	"The wbr element represents a line break opportunity."
	^ self brush: WAOptionalBreakTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 2/2/2011 19:48'!
lineBreakOpportunity: aBlock
	self lineBreakOpportunity with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 10/28/2007 14:42'!
listItem
	"Defines a list item."

	^ self tag: 'li'! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'avi 6/3/2005 15:40'!
listItem: aBlock
	self listItem with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-images' stamp: 'lr 10/28/2007 14:42'!
map
	"Defines an anchor to be used around an image."

	^ self brush: WAImageMapTag new! !

!WAHtmlCanvas methodsFor: 'tags-images' stamp: 'lr 4/9/2007 17:47'!
map: aBlock
	self map with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 9/25/2011 11:45'!
marked
	"no known browser support
	
	The mark element represents a run of text in one document marked or highlighted for reference purposes.

In the following snippet, a paragraph of text refers to a specific part of a code fragment.

<p>The highlighted part below is where the error lies:</p>
<pre><code>var i: Integer;
begin
   i := <mark>1.1</mark>;
end.</code></pre>

Another example of the mark element is highlighting parts of a document that are matching some search string. If someone looked at a document, and the server knew that the user was searching for the word 'kitten', then the server might return the document with one paragraph modified as follows:

<p>I also have some <mark>kitten</mark>s who are visiting me
these days. They're really cute. I think they like my garden!! Maybe I
should adopt a <mark>kitten</mark>.</p>"
	^ self tag: 'mark'! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 3/18/2007 13:29'!
marked: aBlock
	self marked with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 8/8/2007 21:59'!
menu
	^ self brush: WAMenuTag new	! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 8/8/2007 21:59'!
menu: aBlock
	self menu with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 3/28/2007 22:36'!
meter
	^ self brush: WAMeterTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 3/28/2007 22:36'!
meter: aBlock
	self meter with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'as 2/6/2011 22:00'!
monthInput
	^ self brush: WAMonthInputTag new! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
multiSelect
	^ self brush: WAMultiSelectTag new! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
multiSelect: aBlock
	^ self multiSelect with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 7/29/2007 10:52'!
navigation
	"The nav element represents a section of a page that links to other pages or to parts within the page: a section with navigation links.

	When used as an inline-level content container, the element represents a paragraph.

	Each nav element potentially has a heading."
	^ self tag: 'nav'! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 7/29/2007 10:52'!
navigation: aBlock
	self navigation with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'as 2/6/2011 22:00'!
numberInput
	^ self brush: WANumberInputTag new! !

!WAHtmlCanvas methodsFor: 'tags-program' stamp: 'lr 10/28/2007 14:42'!
object
	"Defines an embedded object."

	^ self brush: WAObjectTag new! !

!WAHtmlCanvas methodsFor: 'tags-program' stamp: 'pmm 2/11/2007 19:31'!
object: aBlock
	self object with: aBlock! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
option
	^ self brush: WAOptionTag new! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
option: aBlock
	^ self option with: aBlock! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
optionGroup
	^ self brush: WAOptionGroupTag new! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
optionGroup: aBlock
	^ self optionGroup with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 10/28/2007 14:42'!
orderedList
	"Defines an ordered list."

	^ self brush: WAOrderedListTag new! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 9/25/2005 11:52'!
orderedList: aBlock
	self orderedList with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 9/28/2011 19:07'!
output
	^ self brush: WAOutputTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 9/28/2011 19:07'!
output: aBlock
	^ self output with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'lr 10/28/2007 14:42'!
paragraph
	"Defines a paragraph."

	^ self tag: 'p'! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'avi 6/3/2005 15:40'!
paragraph: aBlock
	self paragraph with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-program' stamp: 'lr 10/28/2007 14:42'!
parameter
	"Defines a parameter for an object."

	^ self brush: WAParameterTag new! !

!WAHtmlCanvas methodsFor: 'tags-program' stamp: 'lr 2/13/2007 00:12'!
parameter: aBlock
	self parameter! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
passwordInput
	^ self brush: WAPasswordInputTag new! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
passwordInput: anObject
	^ self passwordInput with: anObject! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'ac 7/3/2005 15:46'!
popupAnchor
	^ self brush: WAPopupAnchorTag new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 7/10/2007 12:12'!
popupAnchor: aBlock
	self popupAnchor with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
preformatted
	"Defines preformatted text."

	^ self tag: 'pre'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'avi 6/3/2005 15:40'!
preformatted: aBlock
	self preformatted with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 3/28/2007 22:42'!
progress
	^ self brush: WAProgressTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 3/28/2007 22:42'!
progress: aBlock
	self progress with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 10/28/2007 14:42'!
quote
	"Defines a short quotation."

	^ self tag: 'q'! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'pmm 9/30/2006 20:06'!
quote: aBlock
	self quote with: aBlock! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
radioButton
	^ self brush: WARadioButtonTag new! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
radioButton: aBlock
	^ self radioButton with: aBlock! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
radioGroup
	^ WARadioGroup canvas: self! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
radioGroup: aBlock
	^ aBlock value: self radioGroup! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'as 2/6/2011 22:00'!
rangeInput
	^ self brush: WARangeInputTag new! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
ruby
	^ self tag: 'ruby'! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
ruby: aBlock
	self ruby with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyParentheses
	^ self tag: 'rp'! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyParentheses: aBlock
	self rubyParentheses with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'pmm 9/26/2011 18:24'!
rubyText
	^ self tag: 'rt'! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyText: aBlock
	self rubyText with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
sample
	"Defines sample computer code."

	^ self tag: 'samp'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 4/9/2007 17:23'!
sample: aBlock
	self sample with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-program' stamp: 'lr 10/28/2007 14:42'!
script
	"Defines a script."

	^ self brush: WAScriptTag new! !

!WAHtmlCanvas methodsFor: 'tags-program' stamp: 'avi 6/3/2005 15:40'!
script: aBlock
	self script with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'as 2/6/2011 22:00'!
searchInput
	^ self brush: WASearchInputTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 1/24/2012 07:19'!
section
	"The section element represents a generic document or application section. A section, in this context, is a thematic grouping of content, typically with a header, possibly with a footer."
	^ self tag: 'section'! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 7/29/2007 10:41'!
section: aBlock
	self section with: aBlock! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
select
	^ self brush: WASelectTag new! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
select: aBlock
	^ self select with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 10/28/2007 14:42'!
small
	"Defines small text."

	^ self tag: 'small'! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'avi 6/3/2005 15:40'!
small: aBlock
	self small with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 7/29/2007 10:50'!
source
	^ self brush: WASourceTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 7/29/2007 10:50'!
source: aBlock
	self source with: aBlock! !

!WAHtmlCanvas methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
spaceEntity
	"The HTML entity representing a space. To be subclassed as needed."

	^ '&nbsp;'! !

!WAHtmlCanvas methodsFor: 'tags-styles' stamp: 'lr 10/28/2007 14:42'!
span
	"Defines a section in a document."

	^ self tag: 'span'! !

!WAHtmlCanvas methodsFor: 'tags-styles' stamp: 'avi 6/3/2005 15:40'!
span: aBlock
	self span with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 10/28/2007 14:42'!
strong
	"Defines strong text."

	^ self tag: 'strong'! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'ac 3/20/2005 01:24'!
strong: aBlock
	self strong with: aBlock! !

!WAHtmlCanvas methodsFor: 'form-buttons' stamp: 'as 2/6/2011 22:01'!
submitButton
	^ self brush: WASubmitButtonTag new! !

!WAHtmlCanvas methodsFor: 'form-buttons' stamp: 'as 2/6/2011 22:01'!
submitButton: anObject
	^ self submitButton with: anObject! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 10/28/2007 14:42'!
subscript
	"Defines subscripted text."

	^ self tag: 'sub'! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 4/9/2007 16:46'!
subscript: aBlock
	self subscript with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 1/24/2012 07:20'!
summary
	"The summary element represents a summary, caption, or legend for the rest of the contents of the summary element's parent details element, if any."
	^ self tag: 'summary'! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 9/26/2011 18:21'!
summary: aBlock
	self summary with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 10/28/2007 14:42'!
superscript
	"Defines superscripted text."

	^ self tag: 'sup'! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 4/9/2007 16:46'!
superscript: aBlock
	self superscript with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
table
	"Defines a table."

	^ self brush: WATableTag new! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 4/9/2007 17:05'!
table: aBlock
	self table with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableBody
	"Defines a table body."

	^ self tag: 'tbody'! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'avi 6/3/2005 15:40'!
tableBody: aBlock
	self tableBody with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableCaption
	"Defines a table caption."

	^ self tag: 'caption'! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'mb 12/8/2006 16:17'!
tableCaption: aBlock
	self tableCaption with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableColumn
	"Defines attributes for table columns."

	^ self brush: WATableColumnTag new! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'mb 12/7/2006 20:27'!
tableColumn: aBlock
	self tableColumn with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableColumnGroup
	"Defines groups of table columns."

	^ self brush: WATableColumnGroupTag new! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'mb 12/7/2006 20:27'!
tableColumnGroup: aBlock
	self tableColumnGroup with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableData
	"Defines a table cell."

	^ self brush: WATableDataTag new! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'avi 6/3/2005 15:40'!
tableData: aBlock
	self tableData with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableFoot
	"Defines a table footer."

	^ self tag: 'tfoot'! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 4/9/2007 17:06'!
tableFoot: aBlock
	^ self tableFoot with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableHead
	"Defines a table header."

	^ self tag: 'thead'! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'avi 6/3/2005 15:40'!
tableHead: aBlock
	self tableHead with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableHeading
	"Defines a table header."

	^ self brush: WATableHeadingTag new! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'ac 3/16/2005 16:15'!
tableHeading: aBlock
	self tableHeading with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableRow
	"Defines a table row."

	^ self tag: 'tr'! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'avi 6/3/2005 15:40'!
tableRow: aBlock
	self tableRow with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'as 2/6/2011 22:00'!
telephoneInput
	^ self brush: WATelephoneInputTag new! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
teletype
	"Defines teletype text."

	^ self tag: 'tt'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 4/9/2007 17:23'!
teletype: aBlock
	self teletype with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'pmm 11/4/2008 20:28'!
textArea
	^ self brush: WATextAreaTag new! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
textArea: anObject
	^ self textArea with: anObject! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
textInput
	^ self brush: WATextInputTag new! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
textInput: anObject
	^ self textInput with: anObject! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 4/20/2007 01:25'!
time
	^ self brush: WATimeTag new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'pmm 4/20/2007 01:26'!
time: aBlock
	self time with: aBlock! !

!WAHtmlCanvas methodsFor: 'form-elements' stamp: 'as 2/6/2011 22:01'!
timeInput
	^ self brush: WATimeInput new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'as 2/6/2011 22:00'!
timeInput5
	^ self brush: WATimeInputTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 9/28/2011 19:19'!
track
	^ self brush: WATrackTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 9/28/2011 19:20'!
track: aBlock
	self track with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 10/28/2007 14:42'!
unorderedList
	"Defines an unordered list."

	^ self brush: WAUnorderedListTag new! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'avi 6/3/2005 15:40'!
unorderedList: aBlock
	self unorderedList with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'as 2/6/2011 22:00'!
urlInput
	^ self brush: WAUrlInputTag new! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
variable
	"Defines a variable."

	^ self tag: 'var'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'pmm 9/30/2006 20:06'!
variable: aBlock
	self variable with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 3/18/2007 12:58'!
video
	^ self brush: WAVideoTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'pmm 3/18/2007 12:58'!
video: aBlock
	self video with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'as 2/6/2011 22:00'!
weekInput
	^ self brush: WAWeekInputTag new! !

!WAHtmlCanvas methodsFor: 'convenience' stamp: 'lr 7/25/2011 19:01'!
withLineBreaksAndUrls: aString
	| stream |
	aString ifNil: [ ^ self ].
	stream := aString readStream.
	[ stream atEnd ] whileFalse: [ 
		self withUrls: stream nextLine.
		stream atEnd
			ifFalse: [ self break ] ]! !

!WAHtmlCanvas methodsFor: 'convenience' stamp: 'jf 9/30/2009 01:06'!
withUrls: aString 
	| stream url |
	stream := aString readStream.
	[ stream atEnd ] whileFalse: 
		[ self text: (stream greaseUpToAll: 'http://').
		stream atEnd ifFalse: 
			[ url := 'http://' , (stream upTo: Character space).
			self anchor
				url: url;
				with: url.
			self text: ' ' ] ]! !

!WATagCanvas methodsFor: 'private' stamp: 'jf 10/19/2008 03:27'!
break
	self subclassResponsibility ! !

!WATagCanvas methodsFor: 'convenience' stamp: 'jf 10/19/2008 03:37'!
space
	self flush.
	self document nextPutAll: self spaceEntity! !

!WATagCanvas methodsFor: 'convenience' stamp: 'jf 10/19/2008 03:18'!
space: anInteger
	anInteger timesRepeat: [ self space ]! !

!WATagCanvas methodsFor: 'private' stamp: 'jf 10/19/2008 03:15'!
spaceEntity
	self subclassResponsibility ! !

!WATagCanvas methodsFor: 'public' stamp: 'jf 10/19/2008 03:13'!
tag: aString
	"Defines a generic tag with the name aString."

	^ self brush: (WAGenericTag tag: aString)! !

!WATagCanvas methodsFor: 'public' stamp: 'pmm 11/5/2008 14:10'!
tag: aString with: aBlock
	(self tag: aString) with: aBlock! !

!WATagCanvas methodsFor: 'convenience' stamp: 'jf 10/19/2008 03:26'!
withLineBreaks: aString
	"Renders text preserving line breaks."
	| stream |
	stream := aString readStream.
	[ stream atEnd ] whileFalse: [
		self text: stream nextLine.
		stream atEnd ifFalse: [ self break ] ]! !

WATagCanvas subclass: #WAXmlCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WAXmlCanvas commentStamp: 'pmm 2/8/2011 07:10' prior: 0!
I'm an abstract canvas base class for building canvas for custom XML dialects.!

!WAXmlCanvas methodsFor: 'private' stamp: 'jf 10/19/2008 11:23'!
break
	^ String with: Character cr with: Character lf! !

!WAXmlCanvas methodsFor: 'convenience' stamp: 'jf 10/19/2008 03:20'!
cdata: aString
	"aString must not include ']]>'
	
	Google says if there is an error in the feed, there is a 0.02% chance
	that this is the cause, combined with the fact that about 7% of all feeds
	have errors there is a (2 / 10000) * (7 / 100) chance this goes wrong.
	Do you deal in chance?
	
	http://googlereader.blogspot.com/2005/12/xml-errors-in-feeds.html"
	self flush.
	self document nextPutAll: '<!![CDATA['.
	self document nextPutAll: aString.
	self document nextPutAll: ']]>'! !

!WAXmlCanvas methodsFor: 'private' stamp: 'lr 7/25/2011 20:13'!
spaceEntity
	^ '&#160;'! !

WAObject subclass: #WABrush
	instanceVariableNames: 'canvas parent closed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WABrush commentStamp: 'lr 3/27/2007 11:18' prior: 0!
I represent a brush to be used on a *WACanvas*.

Instance Variables
	canvas:		The canvas instance I am used with.
	parent:		The parent brush I am used within.
	closed:		Wether I have been closed/flushed yet.!

!WABrush methodsFor: 'public' stamp: 'lr 4/9/2007 16:32'!
close
	"Close and flush the receiver onto the canvas and its associated document."

	closed ifFalse: [ self with: nil ]! !

!WABrush methodsFor: 'initialization' stamp: 'jf 8/30/2008 16:29'!
initialize
	super initialize.
	closed := false! !

!WABrush methodsFor: 'private' stamp: 'lr 3/27/2007 17:38'!
labelForSelector: aSymbol of: anObject
	^ anObject labelForSelector: aSymbol! !

!WABrush methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:27'!
parent
	^ parent! !

!WABrush methodsFor: 'initialization' stamp: 'avi 6/13/2004 00:27'!
setParent: aBrush canvas: aCanvas
	parent := aBrush.
	canvas := aCanvas! !

!WABrush methodsFor: 'public' stamp: 'lr 3/27/2007 11:10'!
with: aBlock
	canvas nest: aBlock.
	closed := true! !

WABrush subclass: #WACompound
	instanceVariableNames: 'callbackBlock value id properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WACompound commentStamp: 'pmm 9/22/2007 22:22' prior: 0!
I am the superclass for stuff that is not html element but you still want to access via the canvas API.!

!WACompound methodsFor: 'private' stamp: 'lr 9/8/2009 19:45'!
addCallback
	self subclassResponsibility! !

!WACompound methodsFor: 'callbacks' stamp: 'lr 10/28/2007 14:42'!
callback: aBlock
	callbackBlock := aBlock! !

!WACompound methodsFor: 'public' stamp: 'lr 3/27/2007 18:00'!
close
	closed ifTrue: [ ^ self ].
	closed := true.
	self with: nil! !

!WACompound methodsFor: 'testing' stamp: 'lr 3/27/2007 17:25'!
hasCallback
	^ callbackBlock notNil! !

!WACompound methodsFor: 'accessing' stamp: 'lr 3/27/2007 17:55'!
id
	^ id! !

!WACompound methodsFor: 'accessing' stamp: 'lr 3/27/2007 17:55'!
id: aString
	id := aString! !

!WACompound methodsFor: 'initialization' stamp: 'lr 3/27/2007 17:51'!
initialize
	super initialize.
	"do not remove properties, it is used by SeasideAsync"
	properties := Dictionary new! !

!WACompound methodsFor: 'callbacks' stamp: 'jf 9/30/2009 00:22'!
on: aSelector of: anObject 
	self value: (anObject perform: aSelector).
	self callback: (GRDelayedSend 
			receiver: anObject
			selector: aSelector asMutator)! !

!WACompound methodsFor: 'accessing' stamp: 'lr 3/27/2007 17:25'!
value
	^ value! !

!WACompound methodsFor: 'accessing' stamp: 'mb 1/30/2006 18:40'!
value: aValue
	value := aValue! !

!WACompound methodsFor: 'public' stamp: 'lr 8/2/2010 18:46'!
with: anObject
	anObject isNil
		ifFalse: [ value := anObject ].
	closed := true! !

WACompound subclass: #WADateInput
	instanceVariableNames: 'options month day year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WADateInput commentStamp: 'pmm 4/30/2007 23:41' prior: 0!
I am a composition of three input fields that allow the user to select year, month and day. #options: can be used to toggle them individually.
The argument for my callback blocks is an instance of Date.

See WADateTimeTest >> #renderDateTimeOn:!

!WADateInput methodsFor: 'private' stamp: 'pmm 11/4/2008 20:27'!
addCallback
	self hasCallback ifFalse: [
		canvas flush.
		^ self ].
	canvas hiddenInput
		callback: [ callbackBlock value: self setValueWithNewDate ];
		 with: nil! !

!WADateInput methodsFor: 'private callbacks' stamp: 'lr 7/25/2011 19:00'!
addDayCallbackToBrush: aBrush
	self hasCallback
		ifFalse: [ ^ self ].
	aBrush callback: [ :v | self day: v ]! !

!WADateInput methodsFor: 'private callbacks' stamp: 'lr 7/25/2011 18:59'!
addMonthCallbackToBrush: aBrush
	self hasCallback
		ifFalse: [ ^ self ].
	aBrush callback: [ :v | self month: v ]! !

!WADateInput methodsFor: 'private callbacks' stamp: 'lr 7/25/2011 19:00'!
addYearCallbackToBrush: aBrush
	self hasCallback
		ifFalse: [ ^ self ].
	aBrush callback: [ :v | self year: v ]! !

!WADateInput methodsFor: 'private callbacks' stamp: 'lr 7/25/2011 19:59'!
day
	^ day! !

!WADateInput methodsFor: 'private callbacks' stamp: 'jf 9/30/2009 01:04'!
day: anIntegerOrString 
	day := anIntegerOrString greaseInteger ifNil: [ 1 ]! !

!WADateInput methodsFor: 'private' stamp: 'lr 7/25/2011 19:59'!
defaultOptions
	^ #(month day year)! !

!WADateInput methodsFor: 'private callbacks' stamp: 'lr 7/25/2011 19:59'!
month
	^ month! !

!WADateInput methodsFor: 'private callbacks' stamp: 'jf 9/30/2009 01:04'!
month: anIntegerOrString 
	month := anIntegerOrString greaseInteger ifNil: [ 1 ]! !

!WADateInput methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:59'!
options
	^ options ifNil: [ self defaultOptions ]! !

!WADateInput methodsFor: 'accessing' stamp: 'mb 11/3/2006 09:58'!
options: anArray
	"Valid values in the array : #year #month #day
	Can be used to control what is shown and in what order
	Default #(month day year)"
	options := anArray! !

!WADateInput methodsFor: 'private-rendering' stamp: 'jf 9/30/2009 00:32'!
renderDay
	| brush |
	brush := canvas textInput
		id: (self id isNil ifFalse: [ self id , '-day' ]);
		value: (GRNumberPrinter new
				padding: $0;
				digits: 2;
				print: day);
		yourself.
	self addDayCallbackToBrush: brush.
	brush
		attributeAt: 'size'
			put: 2;
		attributeAt: 'maxlength'
			put: 2! !

!WADateInput methodsFor: 'private-rendering' stamp: 'lr 7/25/2011 19:00'!
renderMonth
	| brush |
	brush := canvas select
		id: self id;
		list: (1 to: 12);
		selected: month;
		yourself.
	self addMonthCallbackToBrush: brush.
	brush labels: [ :ea | Date nameOfMonth: ea ]! !

!WADateInput methodsFor: 'private-rendering' stamp: 'jf 9/30/2009 00:32'!
renderYear
	| brush |
	brush := canvas textInput
		id: (self id isNil ifFalse: [ self id , '-year' ]);
		value: (GRNumberPrinter new
				padding: $0;
				digits: 4;
				print: year);
		yourself.
	self addYearCallbackToBrush: brush.
	brush
		attributeAt: 'size'
			put: 4;
		attributeAt: 'maxlength'
			put: 4! !

!WADateInput methodsFor: 'private callbacks' stamp: 'lr 7/25/2011 19:59'!
setValueWithNewDate
	^ value := Date
		newDay: ((day min: (Date daysInMonth: (Date nameOfMonth: month) forYear: year)) max: 1)
		month: (Date nameOfMonth: month)
		year: year! !

!WADateInput methodsFor: 'public' stamp: 'pmm 9/1/2012 11:09'!
with: anObject
	super with: anObject.
	value isNil ifTrue: [ value := Date today ].
	day := value dayOfMonth.
	month := value monthIndex.
	year := value year.
	self options
		do: [ :each | self perform: ('render', each asLowercase capitalized) asSymbol ]
		separatedBy: [ canvas space ].
	self addCallback 
! !

!WADateInput methodsFor: 'private callbacks' stamp: 'lr 7/25/2011 19:59'!
year
	^ year! !

!WADateInput methodsFor: 'private callbacks' stamp: 'jf 9/30/2009 01:04'!
year: anIntegerOrString 
	year := anIntegerOrString greaseInteger ifNil: [ 1900 ]! !

WACompound subclass: #WATimeInput
	instanceVariableNames: 'withSeconds hours minutes seconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATimeInput commentStamp: 'pmm 4/30/2007 23:41' prior: 0!
I am a composition of three input fields that allows the user to select hour, minute and optionally second.
#withSeconds and #withoutSeconds can be used to toggle seconds.

The argument for my callback blocks is an instance of Time.

See WADateTimeTest >> #renderDateTimeOn:!

!WATimeInput methodsFor: 'private' stamp: 'pmm 11/4/2008 20:27'!
addCallback
	self hasCallback ifFalse: [
		canvas flush.
		^ self ].
	canvas hiddenInput
		callback: [ callbackBlock value: self setValueWithNewTime ];
		 with: nil! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 7/25/2011 19:04'!
addHoursCallbackToBrush: aBrush
	self hasCallback
		ifFalse: [ ^ self ].
	aBrush callback: [ :v | self hours: v ]! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 7/25/2011 19:04'!
addMinutesCallbackToBrush: aBrush
	self hasCallback
		ifFalse: [ ^ self ].
	aBrush callback: [ :v | self minutes: v ]! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 7/25/2011 19:04'!
addSecondsCallbackToBrush: aBrush
	self hasCallback
		ifFalse: [ ^ self ].
	aBrush callback: [ :v | self seconds: v ]! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 7/25/2011 20:12'!
hours
	^ hours! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'jf 9/30/2009 01:04'!
hours: anIntegerOrString 
	hours := anIntegerOrString greaseInteger ifNil: [ 0 ]! !

!WATimeInput methodsFor: 'initialization' stamp: 'pmm 9/12/2006 19:18'!
initialize
	super initialize.
	self withoutSeconds! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 7/25/2011 20:12'!
minutes
	^ minutes! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'jf 9/30/2009 01:04'!
minutes: anIntegerOrString 
	minutes := anIntegerOrString greaseInteger ifNil: [ 0 ]! !

!WATimeInput methodsFor: 'private-rendering' stamp: 'jf 9/30/2009 00:32'!
renderHours
	| brush |
	brush := canvas textInput
		id: self id;
		value: (GRNumberPrinter new
				padding: $0;
				digits: 2;
				print: hours).
	self addHoursCallbackToBrush: brush.
	brush
		attributeAt: 'size'
			put: 2;
		attributeAt: 'maxlength'
			put: 2! !

!WATimeInput methodsFor: 'private-rendering' stamp: 'jf 9/30/2009 00:32'!
renderMinutes
	| brush |
	brush := canvas textInput
		id: (self id isNil ifFalse: [ self id , '-mins' ]);
		value: (GRNumberPrinter new
				padding: $0;
				digits: 2;
				print: minutes);
		yourself.
	self addMinutesCallbackToBrush: brush.
	brush
		attributeAt: 'size'
			put: 2;
		attributeAt: 'maxlength'
			put: 2! !

!WATimeInput methodsFor: 'private-rendering' stamp: 'jf 9/30/2009 00:32'!
renderSeconds
	| brush |
	brush := canvas textInput
		id: (self id isNil ifFalse: [ self id , '-secs' ]);
		value: (GRNumberPrinter new
				padding: $0;
				digits: 2;
				print: seconds);
		yourself.
	self addSecondsCallbackToBrush: brush.
	brush
		attributeAt: 'size'
			put: 2;
		attributeAt: 'maxlength'
			put: 2! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 7/25/2011 20:12'!
seconds
	^ seconds! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 7/25/2011 19:04'!
seconds: anIntegerOrString
	seconds := [ anIntegerOrString asNumber ] on: Error do: [ :e | 0 ]! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 7/25/2011 20:12'!
setValueWithNewTime
	^ value := Time hour: hours minute: (minutes min: 59) second: (seconds min: 59)! !

!WATimeInput methodsFor: 'public' stamp: 'lr 7/25/2011 19:04'!
with: anObject
	super with: anObject.
	value isNil
		ifTrue: [ value := Time now ].
	hours := value hour.
	minutes := value minute.
	seconds := value second.
	self renderHours.
	canvas
		space;
		text: ':';
		space.
	self renderMinutes.
	withSeconds
		ifTrue: [ 
			canvas
				space;
				text: ':';
				space.
			self renderSeconds ]
		ifFalse: [ seconds := 0 ].
	self addCallback! !

!WATimeInput methodsFor: 'accessing' stamp: 'mb 2/6/2006 09:55'!
withSeconds
	withSeconds := true! !

!WATimeInput methodsFor: 'accessing' stamp: 'mb 2/6/2006 09:56'!
withoutSeconds
	withSeconds := false! !

WABrush subclass: #WATagBrush
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WATagBrush commentStamp: 'pmm 2/18/2011 23:07' prior: 0!
This is the superclass for all XML element classes. Its main additions are
- element name (#tag)
- attributes (instance of WAHtmlAttributes)
- common events (onXXX), this is a hack and would better be solved with traits!

WATagBrush subclass: #WAAnchorTag
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAAnchorTag commentStamp: 'lr 7/4/2007 20:42' prior: 0!
I'm the class responsible for adding anchors (links) to your webpage. There are multiple ways of using me.

1. In the following case, the method #doSomethingOnClick will be sent to self when the user click on the anchor 'Click here to do something':

	html anchor
		callback: [ self doSomethingOnClick ];
		with: 'Click here to do something'.
		
The following code is a shortcut to create an anchor. The executed action is #doSomethingOnClick and the text is 'Do Something On Click':

	html anchor
		on: #doSomethingOnClick of: self

2. In the following case, a link to an external resource will be generated:

	html anchor
		url: 'http://www.seaside.st';
		with: 'Visit the Seaside'!

!WAAnchorTag methodsFor: 'callbacks' stamp: 'jf 2/15/2010 02:03'!
callback: aNiladicValuable 
	aNiladicValuable argumentCount > 0 ifTrue: [ GRInvalidArgumentCount signal: 'Anchors expect a niladic callback.' ].
	self url addField: (self storeCallback: (WAActionCallback on: aNiladicValuable))! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'lr 12/28/2008 11:05'!
charset: aString
	"This attribute specifies the character encoding of the resource designated by the link."
	
	self attributes at: 'charset' put: aString! !

!WAAnchorTag methodsFor: 'url' stamp: 'jf 2/15/2010 02:04'!
extraParameters: aString
	self url addField: aString! !

!WAAnchorTag methodsFor: 'url' stamp: 'pmm 10/7/2007 14:32'!
extraPath: aString
	self url addToPath: aString! !

!WAAnchorTag methodsFor: 'url' stamp: 'lr 8/17/2007 15:16'!
fragment: aString
	self url fragment: aString! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'pmm 2/8/2011 21:25'!
media: aString
	"This attribute specifies the intended destination medium for style information. It may be a single media descriptor or a comma-separated list. The default value for this attribute is 'screen'."
	self attributeAt: 'media' put: aString! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'lr 12/28/2008 11:00'!
name: aString
	"This attribute names the current anchor so that it may be the destination of another link. The value of this attribute must be a unique anchor name. The scope of this name is the current document. Note that this attribute shares the same name space as the id attribute."

	self attributes at: 'name' put: aString! !

!WAAnchorTag methodsFor: 'public' stamp: 'jf 2/15/2010 02:05'!
navigation
	"Makes the receiving anchor a purely navigational link, this is it won't redirect after processing the callbacks but directly process with the render phase. Don't use this feature if you change your model in the callback'."

	self url addField: '_n'! !

!WAAnchorTag methodsFor: 'callbacks' stamp: 'jf 9/30/2009 00:22'!
on: aSymbol of: anObject 
	self callback: (GRDelayedSend 
			receiver: anObject
			selector: aSymbol).
	self with: (self 
			labelForSelector: aSymbol
			of: anObject)! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'lr 12/28/2008 11:01'!
relationship: aString
	"This attribute describes the relationship from the current document to the anchor specified by the href attribute. The value of this attribute is a space-separated list of link types."
	
	self attributes at: 'rel' append: aString! !

!WAAnchorTag methodsFor: 'url' stamp: 'jf 2/21/2009 18:31'!
resourceUrl: aString
	self url: (canvas absoluteUrlForResource: aString)! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'lr 12/28/2008 11:04'!
reverse: aString
	"This attribute is used to describe a reverse link from the anchor specified by the href attribute to the current document. The value of this attribute is a space-separated list of link types."
	
	self attributes at: 'rev' append: aString! !

!WAAnchorTag methodsFor: 'accessing' stamp: 'lr 8/17/2007 15:15'!
tag
	^ 'a'! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'lr 12/28/2008 11:05'!
target: aString 
	"This attribute specifies the name of a frame where a document is to be opened."
	
	self attributes at: 'target' put: aString! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'lr 12/28/2008 11:26'!
type: aString
	"This attribute gives an advisory hint as to the content type of the content available at the link target address. It allows user agents to opt to use a fallback mechanism rather than fetch the content if they are advised that they will get content in a content type they do not support."
	
	self attributes at: 'type' put: aString! !

!WAAnchorTag methodsFor: 'accessing' stamp: 'jf 2/21/2009 10:41'!
url
	^ url ifNil: [ url := canvas actionUrl copy ]! !

!WAAnchorTag methodsFor: 'accessing' stamp: 'lr 9/8/2009 12:50'!
url: aUrlOrString
	url := aUrlOrString! !

!WAAnchorTag methodsFor: 'public' stamp: 'lr 3/9/2009 19:26'!
useBaseUrl
	"Instead of using the URL of the current page that has been modified through #updateUrl:, use the base URL."

	self url: canvas actionBaseUrl copy! !

!WAAnchorTag methodsFor: 'public' stamp: 'lr 12/28/2008 11:25'!
with: aBlock
	url isNil
		ifFalse: [ self attributes at: 'href' put: url ].
	super with: aBlock! !

WAAnchorTag subclass: #WAImageMapTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAImageMapTag commentStamp: 'pmm 9/14/2013 16:02' prior: 0!
A WAImageMapTag is supposed to be used like this:

	html map
		callback: [ :point | self click: point ];
		with: [ html image url: 'foo.gif' ]
			
An example can be found in WAScreenshot.

Technical:
http://www.w3.org/TR/html4/struct/objects.html#include-maps

The location clicked is passed to the server as follows. The user agent derives a new URI from the URI specified by the href attribute of the A element, by appending `?' followed by the x and y coordinates, separated by a comma. The link is then followed using the new URI. For instance, in the given example, if the user clicks at the location x=10, y=27 then the derived URI is "http://www.acme.com/cgi-bin/competition?10,27".
!

!WAImageMapTag methodsFor: 'callbacks' stamp: 'jf 2/15/2010 02:08'!
callback: aBlock
	"The parameter for the image-map callback must be the last one, as the web-browser will use the same name and replace it with the coordinates."

	self url addField: (self storeCallback: (WAMapCallback on: aBlock)) value: ''! !

WAAnchorTag subclass: #WAPopupAnchorTag
	instanceVariableNames: 'windowTitle features'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAPopupAnchorTag commentStamp: 'pmm 9/14/2013 16:02' prior: 0!
I am used to create a link that opens in a new window. A name can be specified using #name: and many features can be configured. Note, that not all features are supported on all web browser platforms. If Javascript is disabled the link will behave like any other anchor.

Most of the time a popup-anchor is created like this:

	html popupAnchor
		callback: [ self session presenter
			show: WACounter new ];
		with: 'Open the counter within a new window'

This code creates a new render-loop and displays a new instance of WACounter within the new browser window.		
!

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:32'!
dependent: aBoolean
	"Specifies whether the new window is closed as well when the parent window gets closed."

	features at: #dependent put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 10/28/2007 14:42'!
extent: aPoint
	"Specifies the width and height of the new window."

	self width: aPoint x; height: aPoint y! !

!WAPopupAnchorTag methodsFor: 'private' stamp: 'pmm 6/26/2011 14:20'!
featureString
	^ String streamContents:  [ :stream | 
		features associations do: [ :association | 
				stream
					nextPutAll: association key;
					nextPut: $=.
				stream nextPutAll: (association value == true 
						ifTrue: [ 'yes' ]
						ifFalse: [
							association value == false 
								ifTrue: [ 'no' ]
								ifFalse: [ association value greaseString ] ]) ]
			separatedBy: [ stream nextPut: $, ] ]! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 10/28/2007 14:42'!
height: anInteger
	"Specifies the height of the new window."

	features at: #height put: anInteger! !

!WAPopupAnchorTag methodsFor: 'initialization' stamp: 'pmm 8/28/2011 18:29'!
initialize
	super initialize.
	windowTitle := '_blank'.
	features := GRSmallDictionary new! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 10/28/2007 14:42'!
left: anInteger
	"Specifies the x coordinate of the top left corner of the new window. "

	features at: #left put: anInteger! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:24'!
location: aBoolean
	"Specifies whether to display the address line in the new window."

	features at: #location put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:25'!
menubar: aBoolean
	"Specifies whether to display the browser menu bar."

	features at: #menubar put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'accessing' stamp: 'pmm 1/22/2012 21:20'!
name
	self
		greaseDeprecatedApi: 'WAPopupAnchorTag>>#name'
		details: 'use WAPopupAnchorTag>>#windowTitle instead.' .
	^ self windowTitle! !

!WAPopupAnchorTag methodsFor: 'accessing' stamp: 'pmm 1/22/2012 21:20'!
name: aString
	"String specifying the name of the new window. If a window with this name already exists, then the new content will be displayed in that existing window, rather than creating a new one."

	self
		greaseDeprecatedApi: 'WAPopupAnchorTag>>#name:'
		details: 'use WAPopupAnchorTag>>#windowTitle: instead.'.
	self windowTitle: aString! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 10/28/2007 14:42'!
position: aPoint
	"Specifies the x and y coordinates of the top left corner of the new window."

	self left: aPoint x; top: aPoint y! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:25'!
resizable: aBoolean
	"Specifies whether the new window is resizable."

	features at: #resizable put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:25'!
scrollbars: aBoolean
	"Specifies whether the new window should have scrollbars."

	features at: #scrollbars put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:24'!
status: aBoolean
	"Specifies whether to display the browser status bar."

	features at: #status put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:24'!
toolbar: aBoolean
	"Specifies whether to display the toolbar in the new window."

	features at: #toolbar put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 10/28/2007 14:42'!
top: anInteger
	"Specifies the y coordinate of the top left corner of the new window. "

	features at: #top put: anInteger! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 10/28/2007 14:42'!
width: anInteger
	"Specifies the width of the new window."

	features at: #width put: anInteger! !

!WAPopupAnchorTag methodsFor: 'accessing' stamp: 'pmm 8/28/2011 18:25'!
windowTitle
	^ windowTitle! !

!WAPopupAnchorTag methodsFor: 'accessing' stamp: 'pmm 8/28/2011 18:26'!
windowTitle: aString
	"String specifying the name of the new window. If a window with this name already exists, then the new content will be displayed in that existing window, rather than creating a new one."

	windowTitle := aString! !

!WAPopupAnchorTag methodsFor: 'public' stamp: 'pmm 8/28/2011 18:29'!
with: aBlock
	self onClick: 'window.open(this.href,' , self windowTitle printString , ',' , self featureString printString , ');return false'.
	super with: aBlock! !

WATagBrush subclass: #WABasicFormTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WABasicFormTag commentStamp: 'MAD 8/30/2008 15:21' prior: 0!
Acts as a basic form, with no defaultAction, and no holding of _s and _c values.
!

!WABasicFormTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
acceptCharset: aString 
	"This attribute specifies the list of character encodings for input data that is accepted by the server processing this form. The value is a space- and/or comma-delimited list of charset values. The client must interpret this list as an exclusive-or list, i.e., the server is able to accept any single character encoding per entity received.

The default value for this attribute is the reserved string 'UNKNOWN'. User agents may interpret this value as the character encoding that was used to transmit the document containing this FORM element."
	self attributes 
		at: 'accept-charset'
		put: aString! !

!WABasicFormTag methodsFor: 'attributes' stamp: 'lr 9/8/2009 12:50'!
action: aUrlOrString
	"This attribute specifies a form processing agent. User agent behavior for a value other than an HTTP URI is undefined."
	self attributes 
		at: 'action'
		put: aUrlOrString! !

!WABasicFormTag methodsFor: 'private' stamp: 'MAD 8/30/2008 14:55'!
defaultUrlCharset
	"the character set used for POSTs that are application/x-www-form-urlencoded
	and GETs
	There are standards that dictate this:
	http://www.w3.org/International/O-URL-code.html
	but that doesn't mean is will work with your favorite old browser"
	^ 'utf-8'! !

!WABasicFormTag methodsFor: 'attributes' stamp: 'obi 2/11/2009 21:45'!
get
	"tells the user agent to use the HTTP GET method to submit this form"
	self method: 'get'! !

!WABasicFormTag methodsFor: 'initialization' stamp: 'pmm 5/26/2010 07:25'!
initialize
	| charSet |
	super initialize.
	charSet := self requestContext charSet.
	charSet isNil
		ifTrue: [ self acceptCharset: self defaultUrlCharset ]
		ifFalse: [ self acceptCharset: charSet ]! !

!WABasicFormTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
method: aString 
	"This attribute specifies which HTTP method will be used to submit the form data set. Possible (case-insensitive) values are 'get' (the default) and 'post'."
	self attributes 
		at: 'method'
		put: aString! !

!WABasicFormTag methodsFor: 'attributes' stamp: 'pmm 5/26/2010 07:19'!
multipart
	"Sets the content type used to submit the form to the server (when the value of method is 'post') to multipart/form-data instead the default application/x-www-form-urlencoded. This should be used in combination with a WAFileUploadTag."
	self attributes 
		at: 'enctype'
		put: 'multipart/form-data'! !

!WABasicFormTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
multipart: aBoolean
	"Sets the content type used to submit the form to the server.
	true: sets the content type to multipart/form-data
	false: leavess the content type to default application/x-www-form-urlencoded"
	aBoolean ifTrue: [ self multipart ]! !

!WABasicFormTag methodsFor: 'attributes' stamp: 'pmm 11/11/2008 22:58'!
name: aString
	"This attribute names the element so that it may be referred to from style sheets or scripts. Note. This attribute has been included for backwards compatibility. Applications should use the id attribute to identify elements."
	self attributes at: 'name' put: aString! !

!WABasicFormTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
noAutocomplete
	self attributes 
		at: 'autocomplete'
		put: 'off'! !

!WABasicFormTag methodsFor: 'attributes' stamp: 'pmm 5/9/2008 19:27'!
post
	"tells the user agent to use the HTTP POST method to submit this form"
	self method: 'post'! !

!WABasicFormTag methodsFor: 'initialization' stamp: 'pmm 8/30/2009 10:27'!
setParent: aBrush canvas: aCanvas
	super setParent: aBrush canvas: aCanvas.
	self post; action: aCanvas actionUrl! !

!WABasicFormTag methodsFor: 'accessing' stamp: 'avi 6/17/2004 11:29'!
tag
	^ 'form'! !

WABasicFormTag subclass: #WAFormTag
	instanceVariableNames: 'defaultAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAFormTag commentStamp: 'pmm 9/15/2007 08:23' prior: 0!
The FORM element acts as a container for input elements and buttons.

Evaluation order:
The input fields callbacks will be evaluated in the order they
appear in the XHTML. Buttons will always be evaluated last, no matter
where they are positioned.!

!WAFormTag methodsFor: 'private' stamp: 'jf 2/15/2010 01:52'!
after
	super after.
	self isGet ifTrue: [
		"Normally we have the session and continuation id in the action URL. However
		in the case of a GET <form> the browser will drop them."
		canvas div: [
			canvas actionUrl queryFields keysAndValuesDo: [ :k :v |
				canvas hiddenInput
					name: k;
					value: v ] ] ]! !

!WAFormTag methodsFor: 'private' stamp: 'lr 11/11/2008 22:58'!
before
	"Define the default action form buttons. Some implementation notes on this feature: (1) a tab-index of -1 is not valid XHTML, but most todays browser accept it and ignore the element in the tab-order. (2) Internet Explorer requires an additional text field (without other functionality) to make the default action work. Other browser should not include this text-field, as it prevents remembering form input."

	super before.
	defaultAction ifNil: [ ^ nil ].
	canvas div: [
		canvas submitButton
			tabIndex: -1;
			value: 'Default';
			callback: defaultAction;
			style: 'position: absolute; top: -100em'.
		self isInternetExplorer ifTrue: [
			canvas textInput
				tabIndex: -1;
				callback: [ :v | ];
				style: 'position: absolute; top: -100em' ] ]! !

!WAFormTag methodsFor: 'callbacks' stamp: 'MAD 8/30/2008 13:05'!
defaultAction: aBlock
	"The default action gets evaluated whenever the user presses submits
	the form by pressing enter without having the focus on a specific
	submit-button."
	defaultAction := aBlock! !

!WAFormTag methodsFor: 'testing' stamp: 'lr 7/25/2011 20:11'!
isGet
	^ (self attributeAt: 'method') = 'get'! !

!WAFormTag methodsFor: 'private' stamp: 'pmm 4/1/2013 13:43'!
isInternetExplorer
	"Tries to find out whether the current request is made by IE. This is extremely unreliable."
	| userAgent |
	userAgent := self requestContext request userAgent.
	^ userAgent notNil
		and: [ (userAgent indexOfSubCollection: 'MSIE' startingAt: 1) ~= 0
		and: [ (userAgent indexOfSubCollection: 'Opera' startingAt: 1) = 0 ] ]! !

WATagBrush subclass: #WABreakTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WABreakTag commentStamp: 'pmm 9/22/2007 22:22' prior: 0!
The BR element forcibly breaks (ends) the current line of text. Authors are advised to use style sheets to control text flow around floating images and other objects.

Prohibiting a line break 

Sometimes authors may want to prevent a line break from occurring between two words. The &nbsp; entity (&#160; or &#xA0;) acts as a space where user agents should not cause a line break.!

!WABreakTag methodsFor: 'testing' stamp: 'lr 3/26/2007 21:10'!
isClosed
	^ true! !

!WABreakTag methodsFor: 'accessing' stamp: 'lr 3/26/2007 21:10'!
tag
	^ 'br'! !

WATagBrush subclass: #WACanvasTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WACanvasTag commentStamp: 'pmm 3/16/2007 11:52' prior: 0!
supported on:
- Firefox 1.5
- Safari 2
- Opera 9

http://www.whatwg.org/specs/web-apps/current-work/#the-canvas
http://developer.mozilla.org/en/docs/Canvas_tutorial!

!WACanvasTag methodsFor: 'attributes' stamp: 'lr 5/18/2006 08:52'!
extent: aPoint
	self width: aPoint x; height: aPoint y! !

!WACanvasTag methodsFor: 'attributes' stamp: 'jf 9/30/2009 01:10'!
height: aNumber 
	self 
		attributeAt: 'height'
		put: aNumber greaseString! !

!WACanvasTag methodsFor: 'accessing' stamp: 'lr 5/18/2006 08:50'!
tag
	^ 'canvas'! !

!WACanvasTag methodsFor: 'attributes' stamp: 'jf 9/30/2009 01:10'!
width: aNumber 
	self 
		attributeAt: 'width'
		put: aNumber greaseString! !

WATagBrush subclass: #WACollectionTag
	instanceVariableNames: 'list selected labelBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WACollectionTag commentStamp: 'pmm 9/14/2013 16:00' prior: 0!
This element allows the use to select one (in single selection mode) or multiple (in single selection mode) elements. Multiple selection can be triggered with #beMultiple, single selection can be triggered with #beSingle .Default is single selection.

The general idea is that you pass the collection of options to #list: and use #labels: to customize their rendering. The selected option(s) can be set with: #selected:.


This whole class is kind of an awkward hack, but noone needs MI anyway. You can always get a way with composition and delegation!

!WACollectionTag methodsFor: 'adding' stamp: 'lr 6/6/2007 13:22'!
add: anObject
	self list add: anObject! !

!WACollectionTag methodsFor: 'adding' stamp: 'lr 6/6/2007 13:22'!
addAll: aCollection
	self list addAll: aCollection! !

!WACollectionTag methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
before
	super before.
	self hasList ifTrue: [
		self list do: [ :each |
			self
				renderListItem: each
				labelled: (self labelForOption: each) ] ]! !

!WACollectionTag methodsFor: 'callbacks' stamp: 'lr 2/6/2010 13:15'!
callback: aBlock
	self subclassResponsibility! !

!WACollectionTag methodsFor: 'testing' stamp: 'lr 6/6/2007 13:30'!
hasList
	^ list notNil and: [ list notEmpty ]! !

!WACollectionTag methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
isSelected: anObject
	"Test if anObject is currently selected."

 	^ selected = anObject! !

!WACollectionTag methodsFor: 'private' stamp: 'lr 6/6/2007 13:53'!
labelForOption: anObject
	^ labelBlock isNil
		ifTrue: [ anObject ]
		ifFalse: [ labelBlock value: anObject ]! !

!WACollectionTag methodsFor: 'callbacks' stamp: 'lr 10/28/2007 14:42'!
labels: aBlock
	"Allows to customize the rendering of list items by passing a one argument block that converts each option to a string. If you need to do custom html rendering for the options use #with: or override #renderOn: in your objects."

	labelBlock := aBlock fixCallbackTemps! !

!WACollectionTag methodsFor: 'accessing' stamp: 'lr 6/6/2007 13:22'!
list
	^ list ifNil: [ list := OrderedCollection new ]! !

!WACollectionTag methodsFor: 'accessing' stamp: 'lr 2/28/2009 22:45'!
list: aCollection
	"Append aCollection of items to display. The rendering can be customized using #labels:."

	aCollection isNil
		ifFalse: [ self addAll: aCollection ]! !

!WACollectionTag methodsFor: 'callbacks' stamp: 'jf 9/30/2009 00:22'!
on: aSelector of: anObject 
	self selected: (anObject perform: aSelector).
	self callback: (GRDelayedSend 
			receiver: anObject
			selector: aSelector asMutator)! !

!WACollectionTag methodsFor: 'private' stamp: 'lr 6/7/2007 07:56'!
renderListItem: anObject labelled: aString
	self subclassResponsibility! !

!WACollectionTag methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
selected: anObject
	"Set anObject to be selected."

	selected := anObject! !

WACollectionTag subclass: #WADatalistTag
	instanceVariableNames: 'valueBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WADatalistTag commentStamp: 'jf 1/20/2013 20:12' prior: 0!
datalist together with the a new list attribute for input is used to make comboboxes:

<input list=browsers>
<datalist id=browsers>
 <option value="Safari">
 <option value="Internet Explorer">
 <option value="Opera">
 <option value="Firefox">
</datalist>

!

!WADatalistTag methodsFor: 'private' stamp: 'jf 1/20/2013 20:51'!
renderListItem: anObject labelled: labelString
	canvas option
		value: (self valueFor: anObject);
		selected: (self isSelected: anObject);
		with: labelString! !

!WADatalistTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
tag
	^ 'datalist'! !

!WADatalistTag methodsFor: 'private' stamp: 'jf 1/20/2013 20:48'!
valueFor: anObject
	^ valueBlock isNil
		ifTrue: [ anObject ]
		ifFalse: [ valueBlock value: anObject ]! !

!WADatalistTag methodsFor: 'accessing' stamp: 'jf 1/20/2013 22:17'!
values: aBlock
	"Allows to customize the rendering of list items by passing a one argument block that converts each option to a string for use in the 'value' attribute. If you need to do more customized html rendering for the options use #with: or override #renderOn: in your objects."

	valueBlock := aBlock fixCallbackTemps! !

WACollectionTag subclass: #WAListTag
	instanceVariableNames: 'callbackBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAListTag commentStamp: 'pmm 6/30/2007 00:46' prior: 0!
Abstract base class for ordered and unordered list tags.

Ordered and unordered lists are rendered in an identical manner except that visual user agents number ordered list items. User agents may present those numbers in a variety of ways. Unordered list items are not numbered.

Both types of lists are made up of sequences of list items defined by the LI element (whose end tag may be omitted).

Lists may also be nested.!

!WAListTag methodsFor: 'callbacks' stamp: 'obi 12/30/2009 14:04'!
callback: aBlock
	callbackBlock := aBlock fixCallbackTemps! !

!WAListTag methodsFor: 'testing' stamp: 'obi 12/30/2009 14:03'!
hasCallback
	^ callbackBlock notNil! !

!WAListTag methodsFor: 'private' stamp: 'obi 12/30/2009 14:04'!
performCallback: anObject
	self hasCallback ifTrue: [ callbackBlock value: anObject ]! !

!WAListTag methodsFor: 'private' stamp: 'lr 6/7/2007 08:01'!
renderListItem: anObject labelled: aString
	canvas listItem
		class: 'option-selected' if: (self isSelected: anObject);
		with: [
			self hasCallback
				ifFalse: [ canvas render: aString ]
				ifTrue: [
					canvas anchor
						callback: [ self performCallback: anObject ];
						with: aString ] ]! !

WAListTag subclass: #WAOrderedListTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAOrderedListTag commentStamp: 'pmm 6/30/2007 00:47' prior: 0!
See superclass comment.!

!WAOrderedListTag methodsFor: 'attributes' stamp: 'pmm 2/8/2011 21:59'!
reversed: aBoolean
	"The reversed attribute is a boolean attribute. If present, it indicates that the list is a descending list (..., 3, 2, 1). If the attribute is omitted, the list is an ascending list (1, 2, 3, ...)."
	self attributes at: 'reversed' put: aBoolean! !

!WAOrderedListTag methodsFor: 'attributes' stamp: 'pmm 2/8/2011 22:00'!
start: anInteger
	"The start attribute, if present, must be a valid integer giving the ordinal value of the first list item.

If the start attribute is present, user agents must parse it as an integer, in order to determine the attribute's value. The default value, used if the attribute is missing or if the value cannot be converted to a number according to the referenced algorithm, is 1 if the element has no reversed attribute, and is the number of child li elements otherwise.

The first item in the list has the ordinal value given by the ol element's start attribute, unless that li element has a value attribute with a value that can be successfully parsed, in which case it has the ordinal value given by that value attribute.

Each subsequent item in the list has the ordinal value given by its value attribute, if it has one, or, if it doesn't, the ordinal value of the previous item, plus one if the reversed is absent, or minus one if it is present.
"
	self attributes at: 'start' put: anInteger! !

!WAOrderedListTag methodsFor: 'accessing' stamp: 'lr 4/9/2007 17:12'!
tag
	^ 'ol'! !

!WAOrderedListTag methodsFor: 'attributes' stamp: 'pmm 2/12/2011 10:03'!
type: aString
	"The type attribute can be used to specify the kind of marker to use in the list, in the cases where that matters (e.g. because items are to be referened by their number/letter). The attribute, if specified, must have a value that is a case-sensitive match for one of the characters given in the first cell of one of the rows of the following table. The type attribute represents the state given in the cell in the second column of the row whose first cell matches the attribute's value; if none of the cells match, or if the attribute is omitted, then the attribute represents the decimal state.
Keyword 	State 	Description 	Examples for values 1-3 and 3999-4001
1 (U+0031) 	decimal 	Decimal numbers 	1. 	2. 	3. 	... 	3999. 	4000. 	4001. 	...
a (U+0061) 	lower-alpha 	Lowercase latin alphabet 	a. 	b. 	c. 	... 	ewu. 	ewv. 	eww. 	...
A (U+0041) 	upper-alpha 	Uppercase latin alphabet 	A. 	B. 	C. 	... 	EWU. 	EWV. 	EWW. 	...
i (U+0069) 	lower-roman 	Lowercase roman numerals 	i. 	ii. 	iii. 	... 	mmmcmxcix. 	iv. 	ivi. 	...
I (U+0049) 	upper-roman 	Uppercase roman numerals 	I. 	II. 	III. 	... 	MMMCMXCIX. 	IV. 	IVI. 	...

User agents should render the items of the list in a manner consistent with the state of the type attribute of the ol element. Numbers less than or equal to zero should always use the decimal system regardless of the type attribute."
	self attributes at: 'type' put: aString! !

WAListTag subclass: #WAUnorderedListTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAUnorderedListTag commentStamp: 'pmm 6/30/2007 00:47' prior: 0!
See superclass comment.!

!WAUnorderedListTag methodsFor: 'accessing' stamp: 'lr 4/9/2007 17:12'!
tag
	^ 'ul'! !

WACollectionTag subclass: #WASelectTag
	instanceVariableNames: 'enabledBlock isOptional optionalLabel titleBlock values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WASelectTag commentStamp: 'pmm 4/24/2007 11:12' prior: 0!
This element allows the use to select one (in single selection mode) or multiple (in single selection mode) elements. Default is single selection. Multiple selection can be triggered with #beMultiple.

Single selection is in general a drop-down list, so make sure the list of options is not too big.
Multiple selection has in general crappy browser support and a list of checkboxes is in general the better option.

If in single selection mode and you want enable "no selection" see #beOptional.

If you absolutely need to you can render the options yourself with 'html option' inside #with:

Make sure to check the superclass for more methods.

See WAInputTest >> #renderSingleSelectionOn: and WAInputTest >> #renderMultiSelectionOn: for examples.!

WASelectTag subclass: #WAMultiSelectTag
	instanceVariableNames: 'callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAMultiSelectTag commentStamp: 'obi 4/2/2008 22:54' prior: 0!
See superclass.!

!WAMultiSelectTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
callbackClass
	^ WAMultipleValuesCallback! !

!WAMultiSelectTag methodsFor: 'private' stamp: 'lr 8/22/2010 16:21'!
closeTag
	super closeTag.
	self hasCallback ifFalse: [ ^ self ].
	canvas hiddenInput
		callback: [ self triggerCallback ].
	canvas flush! !

!WAMultiSelectTag methodsFor: 'testing' stamp: 'lr 6/6/2007 16:14'!
isSelected: anObject
	^ selected notNil and: [ selected includes: anObject ]! !

!WAMultiSelectTag methodsFor: 'private' stamp: 'obi 12/30/2009 15:10'!
openTag
	self attributes at: 'multiple' put: true.
	super openTag
! !

!WAMultiSelectTag methodsFor: 'private' stamp: 'lr 8/22/2010 16:07'!
storeCallback: aCallback
	^ super storeCallback: (callback := aCallback)! !

!WAMultiSelectTag methodsFor: 'private' stamp: 'lr 8/22/2010 16:17'!
triggerCallback
	"Ensure that the callback triggers even if the browser does not submit a value."

	self requestContext request
		at: callback key
		ifAbsent: [ callback evaluateWithFieldValues: #() ]! !

!WASelectTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
beOptional
	"This adds a nil item to #list: which has the semantic of no selection. #optionalLabel: is the label for nil. This only really makes sense in single selection mode."

	isOptional := true! !

!WASelectTag methodsFor: 'private' stamp: 'lr 6/6/2007 17:44'!
before
	self isOptional ifTrue: [ self renderOptional ].
	super before! !

!WASelectTag methodsFor: 'callbacks' stamp: 'obi 12/30/2009 14:28'!
callback: aBlock
	values := Dictionary new.
	self name: (self storeCallback: (self callbackClass on: aBlock values: values))! !

!WASelectTag methodsFor: 'accessing' stamp: 'lr 1/23/2010 14:04'!
callbackClass
	^ WAValuesCallback! !

!WASelectTag methodsFor: 'callbacks' stamp: 'lr 1/23/2010 14:05'!
dispatchCallback
	^ self name: (self storeCallback: WADispatchCallback new)! !

!WASelectTag methodsFor: 'callbacks' stamp: 'lr 1/23/2010 14:03'!
enabled: aOneArgumentBlock
	"Enable only those elements for selection for whom aBlock return true."

	enabledBlock := aOneArgumentBlock fixCallbackTemps! !

!WASelectTag methodsFor: 'accessing' stamp: 'obi 12/30/2009 14:02'!
hasCallback
	^ values notNil! !

!WASelectTag methodsFor: 'initialization' stamp: 'lr 1/23/2010 14:03'!
initialize
	super initialize.
	isOptional := false
	! !

!WASelectTag methodsFor: 'testing' stamp: 'lr 6/6/2007 16:21'!
isEnabled: anObject
	"Test if anObject is enabled."

 	^ enabledBlock isNil or: [ enabledBlock value: anObject ]! !

!WASelectTag methodsFor: 'testing' stamp: 'lr 6/6/2007 17:42'!
isOptional
	^ isOptional! !

!WASelectTag methodsFor: 'attributes' stamp: 'pmm 8/7/2007 18:45'!
listId: aString
	"aString is the id of a datalist"
	self attributeAt: 'list' put: aString! !

!WASelectTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
name: aString
	"This attribute assigns the control name."

	self attributes at: 'name' put: aString! !

!WASelectTag methodsFor: 'private' stamp: 'lr 1/23/2010 14:03'!
nextKey
	^ values size + 1
! !

!WASelectTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
optionalLabel: aString
	"The label for the nil element. See #beOptional."

	optionalLabel := aString! !

!WASelectTag methodsFor: 'private' stamp: 'lr 1/23/2010 13:53'!
renderListItem: anObject labelled: aString
	| option |
	option := canvas option.
	self hasCallback
		ifTrue: [ option value: (self valueFor: anObject) ].
	titleBlock isNil
		ifFalse: [ option title: (self titleFor: anObject) ].
	option
		selected: (self isSelected: anObject);
		disabled: (self isEnabled: anObject) not;
		with: aString! !

!WASelectTag methodsFor: 'private' stamp: 'lr 6/7/2007 07:58'!
renderOptional
	self renderListItem: nil labelled: optionalLabel! !

!WASelectTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
size: aNumber
	"If a SELECT element is presented as a scrolled list box, this attribute specifies the number of rows in the list that should be visible at the same time. Visual user agents are not required to present a SELECT element as a list box; they may use any other mechanism, such as a drop-down menu."

	self attributes at: 'size' put: aNumber! !

!WASelectTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 16:44'!
tag
	^ 'select'! !

!WASelectTag methodsFor: 'private' stamp: 'lr 1/23/2010 13:53'!
titleFor: anObject
	^ titleBlock isNil
		ifTrue: [ anObject ]
		ifFalse: [ titleBlock value: anObject ]! !

!WASelectTag methodsFor: 'callbacks' stamp: 'pmm 7/5/2009 13:21'!
titles: aOneArgumentBlock
	"The given block will be used to generated title attributes for any of the options."

	titleBlock := aOneArgumentBlock fixCallbackTemps! !

!WASelectTag methodsFor: 'private' stamp: 'lr 1/23/2010 14:04'!
valueFor: anObject
	^ self valuesAt: self nextKey put: anObject! !

!WASelectTag methodsFor: 'accessing' stamp: 'lr 1/23/2010 14:04'!
valuesAt: key put: anObject
	values at: key put: anObject.
	^ values size! !

WATagBrush subclass: #WACommandTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WACommandTag commentStamp: 'pmm 8/8/2007 22:00' prior: 0!
The command element represents a command that the user can invoke.!

!WACommandTag methodsFor: 'attributes' stamp: 'pmm 8/8/2007 22:03'!
beCheckbox
	self type: 'checkbox'! !

!WACommandTag methodsFor: 'attributes' stamp: 'pmm 8/8/2007 22:06'!
beChecked
	self checked: true! !

!WACommandTag methodsFor: 'attributes' stamp: 'pmm 8/8/2007 22:03'!
beCommand
	self type: 'command'! !

!WACommandTag methodsFor: 'attributes' stamp: 'pmm 8/8/2007 22:06'!
beDisabled
	self disabled: true! !

!WACommandTag methodsFor: 'attributes' stamp: 'pmm 8/8/2007 22:06'!
beHidden
	self hidden: true! !

!WACommandTag methodsFor: 'attributes' stamp: 'pmm 8/8/2007 22:03'!
beRadio
	self type: 'radio'! !

!WACommandTag methodsFor: 'attributes' stamp: 'pmm 8/8/2007 22:05'!
checked: aBoolean
	"The checked attribute is a boolean attribute that, if present, indicates that the command is selected."
	self attributeAt: 'checked' put: aBoolean! !

!WACommandTag methodsFor: 'attributes' stamp: 'pmm 8/8/2007 22:05'!
disabled: aBoolean
	"The disabled attribute is a boolean attribute that, if present, indicates that the command is not available in the current state."
	self attributeAt: 'disabled' put: aBoolean! !

!WACommandTag methodsFor: 'attributes' stamp: 'pmm 8/8/2007 22:05'!
hidden: aBoolean
	"The hidden  attribute is a boolean attribute that, if present, indicates that the command is not relevant and is to be hidden."
	self attributeAt: 'hidden' put: aBoolean! !

!WACommandTag methodsFor: 'attributes' stamp: 'pmm 8/8/2007 22:04'!
icon: aString
	"The icon  attribute gives a picture that represents the command. If the attribute is specified, the attribute's value must contain a URI (or IRI)."
	self attributeAt: 'icon' put: aString! !

!WACommandTag methodsFor: 'attributes' stamp: 'pmm 8/8/2007 22:04'!
label: aString
	"The label  attribute gives the name of the command, as shown to the user."
	self attributeAt: 'label' put: aString! !

!WACommandTag methodsFor: 'accessing' stamp: 'pmm 8/8/2007 22:01'!
tag
	^ 'command'! !

!WACommandTag methodsFor: 'attributes' stamp: 'pmm 8/8/2007 22:02'!
type: aString
	"The type  attribute indicates the kind of command: either a normal command with an associated action, or a state or option that can be toggled, or a selection of one item from a list of items.

The attribute's value must be either 'command', 'checkbox', or 'radio', denoting each of these three types of commands respectively. The attribute may also be omitted if the element is to represent the first of these types, a simple command. "
	self attributeAt: 'type' put: aString! !

WATagBrush subclass: #WADetailsTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WADetailsTag commentStamp: 'pmm 7/29/2007 00:33' prior: 0!
The details element represents additional information or controls which the user can obtain on demand.

The first element child of a details element, if it is a legend element, represents the summary of the details.

If the first element is not a legend element, the UA should provide its own legend (e.g. "Details"). !

!WADetailsTag methodsFor: 'attributes' stamp: 'pmm 8/8/2007 22:09'!
open: aBoolean
	"The open  content attribute is a boolean attribute. If present, it indicates that the details should be shown to the user. If the attribute is absent, the details should not be shown.

	If the attribute is removed, then the details should be hidden. If the attribute is added, the details should be shown."
	self attributeAt: 'open' put: aBoolean! !

!WADetailsTag methodsFor: 'accessing' stamp: 'pmm 8/8/2007 22:09'!
tag
	^ 'details'! !

WATagBrush subclass: #WADivTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WADivTag commentStamp: 'obi 4/2/2008 22:48' prior: 0!
The <div> tag defines a division/section in a document.

Use the <div> tag to group block-elements to format them with styles.
!

!WADivTag methodsFor: 'accessing' stamp: 'avi 6/3/2005 15:39'!
tag
	^ 'div'! !

WATagBrush subclass: #WAEmbedTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAEmbedTag methodsFor: 'attributes' stamp: 'as 2/1/2011 16:40'!
height: anInteger
	self attributeAt: 'height' put: anInteger! !

!WAEmbedTag methodsFor: 'accessing' stamp: 'as 2/1/2011 16:37'!
tag
	^ 'embed'! !

!WAEmbedTag methodsFor: 'attributes' stamp: 'as 2/1/2011 17:00'!
type: aMimeType
	self attributeAt: 'type' put: aMimeType! !

!WAEmbedTag methodsFor: 'attributes' stamp: 'pmm 2/2/2011 19:43'!
url: aString
	"The src attribute gives the address of the resource being embedded."
	self attributeAt: 'src' put: aString! !

!WAEmbedTag methodsFor: 'attributes' stamp: 'as 2/1/2011 16:40'!
width: anInteger
	self attributeAt: 'width' put: anInteger! !

WATagBrush subclass: #WAEventSourceTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAEventSourceTag commentStamp: 'pmm 7/29/2007 00:49' prior: 0!
The event-source element represents a target for events generated by a remote server.

The src attribute, if specified, must give a URI (or IRI) pointing to a resource that uses the application/x-dom-event-stream format.

When the element is inserted into the document, if it has the src attribute specified, the user agent must act as if the addEventSource() method on the event-source element had been invoked with the URI resulting from resolving the src attribute's value to an absolute URI.

While the element is in a document, if its src attribute is mutated, the user agent must act as if first the removeEventSource() method on the event-source element had been invoked with the URI resulting from resolving the old value of the attribute to an absolute URI, and then as if the addEventSource() method on the element had been invoked with the URI resulting from resolving the new value of the src attribute to an absolute URI.

When the element is removed from the document, if it has the src attribute specified, or, when the src attribute is about to be removed, the user agent must act as if the removeEventSource() method on the event-source element had been invoked with the URI resulting from resolving the src attribute's value to an absolute URI.

There can be more than one event-source element per document, but authors should take care to avoid opening multiple connections to the same server as HTTP recommends a limit to the number of simultaneous connections that a user agent can open per server.

The src DOM attribute must reflect the content attribute of the same name. !

!WAEventSourceTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
tag
	^ 'event-source'! !

!WAEventSourceTag methodsFor: 'attributes' stamp: 'pmm 7/29/2007 00:49'!
url: aString
	"The src  attribute, if specified, must give a URI (or IRI) pointing to a resource that uses the application/x-dom-event-stream format."
	self attributeAt: 'src' put: aString! !

WATagBrush subclass: #WAFieldSetTag
	instanceVariableNames: 'legend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAFieldSetTag commentStamp: 'pmm 5/10/2007 10:12' prior: 0!
The FIELDSET element allows authors to group thematically related controls and labels. Grouping controls makes it easier for users to understand their purpose while simultaneously facilitating tabbing navigation for visual user agents and speech navigation for speech-oriented user agents. The proper use of this element makes documents more accessible.

The LEGEND element allows authors to assign a caption to a FIELDSET. The legend improves accessibility when the FIELDSET is rendered non-visually.!

!WAFieldSetTag methodsFor: 'private' stamp: 'lr 2/28/2009 22:42'!
before
	super before.
	legend isNil
		ifFalse: [ canvas legend: legend ]! !

!WAFieldSetTag methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
legend: aString
	legend := aString! !

!WAFieldSetTag methodsFor: 'accessing' stamp: 'mb 3/8/2006 17:44'!
tag
	^ 'fieldset'! !

WATagBrush subclass: #WAFormInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAFormInputTag commentStamp: 'obi 4/2/2008 22:49' prior: 0!
The <input> tag defines the start of an input field where the user can enter data.!

WAFormInputTag subclass: #WAAbstractTextAreaTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAAbstractTextAreaTag commentStamp: 'pmm 4/23/2007 21:10' prior: 0!
An abstract class to describe the HTML elements that allow the user to enter text.!

!WAAbstractTextAreaTag methodsFor: 'private' stamp: 'pmm 4/22/2012 16:09'!
allValuesCallbackClass
	^ WAAllValuesCallback! !

!WAAbstractTextAreaTag methodsFor: 'private' stamp: 'pmm 4/21/2012 19:38'!
beMultiple
	"The multiple attribute is a boolean attribute that indicates whether the user is to be allowed to specify more than one value."
	self attributeAt: 'multiple' put: true! !

!WAAbstractTextAreaTag methodsFor: 'callbacks' stamp: 'MAD 2/20/2009 16:04'!
callback: aBlock
	self name: (self storeCallback: (WAValueCallback on: aBlock)).
	self value: self value! !

!WAAbstractTextAreaTag methodsFor: 'attributes' stamp: 'pmm 4/21/2012 19:51'!
listId: aString
	"aString is the id of a datalist"
	self attributeAt: 'list' put: aString! !

!WAAbstractTextAreaTag methodsFor: 'callbacks' stamp: 'pmm 4/22/2012 16:09'!
multipleValuesCallback: aBlock
	self beMultiple.
	self name: (self storeCallback: (self allValuesCallbackClass on: aBlock)).
	self value: self value! !

!WAAbstractTextAreaTag methodsFor: 'attributes' stamp: 'pmm 3/30/2007 11:53'!
pattern: aString
	"no known browser support
	
	For the text, password, email, and url types of the input element, and for the textarea element, the pattern attribute specifies a pattern that the control value must match. 

When specified, the pattern attribute contains a regular expression that the control's value must match before the form may be submitted.

	The regular expression language used for this attribute is the same as that defined in [ECMA262], except that the pattern attribute must match the entire value, not just any subset (somewhat as if it implied a ^(?: at the start of the pattern and a )$ at the end). The pattern must be compiled with the global, ignoreCase, and multiline flags disabled (see ECMA262, sections 15.10.7.2 through 15.10.7.4). If the attribute is omitted then the control has no pattern restriction.
	
	The / character is not special in the pattern attribute. The two attributes pattern='/etc/.+' and pattern='\/etc\/.+' are therefore equivalent. 

	In the case of the email and url types, the pattern attribute specifies a pattern that must be matched in addition to the value matching the generic pattern relevant for the control."
	self attributeAt: 'pattern' put: aString! !

!WAAbstractTextAreaTag methodsFor: 'attributes' stamp: 'pmm 8/1/2010 14:09'!
placeholder: aString
	"The placeholder  attribute represents a short hint (a word or short phrase) intended to aid the user with data entry. A hint could be a sample value or a brief description of the expected format. The attribute, if specified, must have a value that contains no U+000A LINE FEED (LF) or U+000D CARRIAGE RETURN (CR) characters."
	self attributeAt: 'placeholder' put: aString! !

WAAbstractTextAreaTag subclass: #WAColorInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAColorInputTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
type
	^ 'color'! !

WAAbstractTextAreaTag subclass: #WAEmailInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAEmailInputTag commentStamp: 'pmm 3/16/2007 13:38' prior: 0!
supported on:
- Opera 9
graceful degeneration to text input

An e-mail address, following the format of the addr-spec  token defined in RFC 2822 section 3.4.1 [RFC2822], but excluding the CFWS  subtoken everywhere, and excluding the FWS subtoken everywhere except in the quoted-string subtoken. UAs could, for example, offer e-mail addresses from the user's address book. (See below for notes on IDN.)!

!WAEmailInputTag methodsFor: 'private' stamp: 'pmm 4/22/2012 16:10'!
allValuesCallbackClass
	^ WAAllEmailsCallback! !

!WAEmailInputTag methodsFor: 'callbacks' stamp: 'pmm 6/14/2009 13:33'!
callback: aBlock
	self name: (self storeCallback: (WAEmailCallback on: aBlock)).
	self value: self value! !

!WAEmailInputTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
type
	^ 'email'! !

WAAbstractTextAreaTag subclass: #WASearchInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WASearchInputTag commentStamp: 'pmm 3/16/2007 13:37' prior: 0!
supported on:
- Safari 1.3 and 2.0
not (yet) part of HTML5
graceful degeneration to text input

http://weblogs.mozillazine.org/hyatt/archives/2004_07.html#005890!

!WASearchInputTag methodsFor: 'attributes' stamp: 'pmm 3/16/2007 11:47'!
autosave: aString
	"The autosave attribute allows you to specify an autosave name for your search results in the dropdown. What's cool about the autosave is that it's global, which means that two Web sites could put up a search field with an autosave name of google and then they would share the search results. (Since the actual result values are not accessible to the page there is no privacy violation.)"
	self attributeAt: 'autosave' put: aString! !

!WASearchInputTag methodsFor: 'attributes' stamp: 'pmm 3/16/2007 11:46'!
incremental: aBoolean
	"The incremental attribute can be used to control whether or not the search is performed as you type."
	self attributeAt: 'incremental' put: aBoolean! !

!WASearchInputTag methodsFor: 'events' stamp: 'pmm 3/16/2007 11:44'!
onSearch: aString
	"The search DOM event fires at the precise time the search should be performed and obeys the heuristic for the control, so you don't have to trap key and click events at all. You can use the onsearch attribute on the control to respond when the search happens."

	self attributes at: 'onsearch' append: aString separator: ';'! !

!WASearchInputTag methodsFor: 'attributes' stamp: 'pmm 3/16/2007 11:43'!
results: aNumber
	"The results attribute allows you to specify how many results should be displayed in the dropdown."
	self attributeAt: 'results' put: aNumber! !

!WASearchInputTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
type
	^ 'search'! !

WAAbstractTextAreaTag subclass: #WASteppedTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

WASteppedTag subclass: #WAClosedRangeTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAClosedRangeTag commentStamp: 'pmm 9/14/2013 16:00' prior: 0!
abstract class for all the elements that have a step, min and max attribute!

!WAClosedRangeTag methodsFor: 'attributes' stamp: 'pmm 3/16/2007 13:02'!
max: anInteger
	self attributeAt: 'max' put: anInteger! !

!WAClosedRangeTag methodsFor: 'attributes' stamp: 'pmm 3/16/2007 13:02'!
min: anInteger
	self attributeAt: 'min' put: anInteger! !

WAClosedRangeTag subclass: #WANumberInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WANumberInputTag commentStamp: 'pmm 3/16/2007 13:38' prior: 0!
supported on:
- Opera 9
graceful degeneration to text input

A numerical value. The step attribute specifies the precision, defaulting to 1.

Numbers must be submitted as a significand followed by an optional exponent. The significand is an optional minus sign (U+002D, "-"), an integer, and optionally a decimal point (U+002E, ".") and an integer representing the fractional part. The exponent is a lowercase literal letter "e", an optional minus sign, and an integer representing the index of a power of ten with which to multiply the significand to get the actual number. Integers are one or more decimal digits. If the exponent part is omitted its index of a power of ten must be assumed to be zero.

For example, negative-root-two, to 32 significant figures, would be -1.4142135623730950488016887242097e0, the radius of the earth given in furlongs, to an arbitrary precision, would be 3.17e4, and the answer to the life, the universe and everything could be any of (amongst others) 42, 0042.000, 42e0, 4.2e1, or 420e-1.

This format is designed to be compatible with scanf(3)'s %f format, ECMAScript's parseFloat, and similar parsers while being easier to parse than some other floating point syntaxes that are also compatible with those parsers.

The strings +0, 0e+0, and +1e+3 are all invalid numbers (the minus sign cannot be replaced by a plus sign for non-negative numbers, it must simply be omitted). Similarly, .42e2 is invalid (there must be at least one digit before the decimal point). UAs must not submit numbers in invalid formats (whatever the user might enter).

The submission format is not intended to be the format seen and used by users. UAs may use whatever format and UI is appropriate for user interaction; the description above is simply the submission format.!

!WANumberInputTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
type
	^ 'number'! !

WAClosedRangeTag subclass: #WARangeInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WARangeInputTag commentStamp: 'pmm 3/16/2007 13:38' prior: 0!
supported on:
- Safari 2.0 (slider)
graceful degeneration to text input

For this type, step defaults to 1, min defaults to 0, max defaults to 100, and value  defaults to the min value.

Volume controls and brightness controls would be good examples of "range" data controls.!

!WARangeInputTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
type
	^ 'range'! !

WAClosedRangeTag subclass: #WATimeInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATimeInputTag commentStamp: 'pmm 3/16/2007 14:05' prior: 0!
supported on:
- Opera 9
graceful degeneration to text input

A time (hour, minute, seconds, fractional seconds) encoded according to ISO 8601 [ISO8601] with no time zone: two digits (0-9) for the hour, a colon (U+003A), two digits for the minute, optionally a colon and two digits for the second, and optionally (if the seconds are present) a period (U+002E) and one or more digits for the fraction of a second. All the numbers must be in base ten and zero-padded if necessary. If the seconds are omitted, they must be assumed to be zero. If the fraction is omitted, it must be assumed to be zero as well. For instance: 23:59:00.00000 or 00:00:05. The step attribute specifies the precision in seconds, defaulting to 60. Times must be greater than or equal to 0 and must be less than 24 hours, in addition to any tighter restrictions placed on the control by the min and max attributes. Note that this type is not an elapsed time data type.

User agents are expected to show an appropriate widget, such as a clock. UAs should make it clear to the user that the time does not carry any time zone information. !

!WATimeInputTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
type
	^ 'time'! !

WASteppedTag subclass: #WADateInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WADateInputTag commentStamp: 'pmm 3/16/2007 14:05' prior: 0!
supported on:
- Opera 9
graceful degeneration to text input

A date (year, month, day) encoded according to ISO 8601 [ISO8601]: four or more digits (0 to 9) representing the year, a hyphen (U+002D), two digits for the month, a hyphen, and two digits for the day. All the numbers must be in base ten and zero padded if necessary. For instance: 1995-12-31. The step attribute specifies the precision in days, defaulting to 1. User agents are expected to show an appropriate widget, such as a datepicker.!

!WADateInputTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
type
	^ 'date'! !

WASteppedTag subclass: #WADateTimeInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WADateTimeInputTag commentStamp: 'pmm 3/16/2007 14:05' prior: 0!
supported on:
- Opera 9
graceful degeneration to text input

A date and time (year, month, day, hour, minute, second, fractions of a second) encoded according to ISO 8601 [ISO8601] with the time zone set to UTC: four or more digits (0 to 9) representing the year, a hyphen (U+002D), two digits for the month, a hyphen, two digits for the day, a literal "T", two digits for the hour, a colon (U+003A), two digits for the minute, optionally a colon and two digits for the second, optionally (if the seconds are present) a period (U+002E) and one or more digits for the fraction of a second, and finally a mandatory literal "Z". All the numbers must be in base ten and zero-padded if necessary. If the seconds are omitted, they must be assumed to be zero. If the fraction is omitted, it must be assumed to be zero as well. For instance: 1995-12-31T23:59:59.99Z or, representing the time 10 milliseconds later, 1996-01-01T00:00Z. The step attribute specifies the precision in seconds, defaulting to 60 (one minute).

User agents are expected to show an appropriate widget. UAs may display the time in whatever time zone is appropriate for the user, but should be clear to the user that the time is globally defined, not time-zone dependent. The submitted date and time must be in the UTC time zone.!

!WADateTimeInputTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
type
	^ 'datetime'! !

WASteppedTag subclass: #WADateTimeLocalInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WADateTimeLocalInputTag commentStamp: 'pmm 3/16/2007 14:05' prior: 0!
supported on:
- Opera 9
graceful degeneration to text input

A date and time (year, month, day, hour, minute, second, fractions of a second) encoded according to ISO 8601 [ISO8601], with no time zone information: four or more digits (0 to 9) representing the year, a hyphen (U+002D), two digits for the month, a hyphen, two digits for the day, a literal "T", two digits for the hour, a colon (U+003A), two digits for the minute, optionally a colon and two digits for the second, and optionally (if the seconds are present) a period (U+002E) and one or more digits for the fraction of a second. All the numbers must be in base ten and zero-padded if necessary. If the seconds are omitted, they must be assumed to be zero. If the fraction is omitted, it must be assumed to be zero as well. For instance: 1995-12-31T23:59:59.99 or, representing the time 10 milliseconds later, 1996-01-01T00:00. The step attribute specifies the precision in seconds, defaulting to 60 (one minute).!

!WADateTimeLocalInputTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
type
	^ 'datetime-local'! !

WASteppedTag subclass: #WAMonthInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAMonthInputTag commentStamp: 'pmm 3/16/2007 14:05' prior: 0!
supported on:
- Opera 9
graceful degeneration to text input

A date consisting of a year and a month encoded according to ISO 8601 [ISO8601]: four or more digits (0 to 9) representing the year, a hyphen (U+002D), and two digits for the month, zero-padded if necessary. All the numbers must be in base ten. For instance: 1995-12. The step  attribute specifies the precision in months, defaulting to 1. This type is used most frequently for credit card expiry dates.!

!WAMonthInputTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
type
	^ 'month'! !

!WASteppedTag methodsFor: 'attributes' stamp: 'pmm 3/16/2007 13:01'!
step: anInteger
	self attributeAt: 'step' put: anInteger! !

WASteppedTag subclass: #WAWeekInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAWeekInputTag commentStamp: 'pmm 3/16/2007 14:05' prior: 0!
supported on:
- Opera 9
graceful degeneration to text input

A date consisting of a year and a week number encoded according to ISO 8601 [ISO8601]: four or more digits (0 to 9) representing the year, a hyphen (U+002D), a literal "W", and two digits for the week, zero-padded if necessary. All the numbers must be in base ten. The week number must be a number greater than or equal to 01. Week 01 of a given year is the week containing the 4th of January; weeks start on Monday. For instance: 2005-W52 is the week that ends on Sunday the first of January, 2006. The step attribute specifies the precision in weeks, defaulting to 1. This type is used most frequently for dates in European industry.!

!WAWeekInputTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
type
	^ 'week'! !

WAAbstractTextAreaTag subclass: #WATelephoneInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATelephoneInputTag methodsFor: 'accessing' stamp: 'NickAger 10/31/2011 14:41'!
type
	^ 'tel'! !

WAAbstractTextAreaTag subclass: #WATextAreaTag
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATextAreaTag commentStamp: 'pmm 4/24/2007 11:13' prior: 0!
I am a multi line text input widget. See WAInputTest >> #renderTextAreaWithExampleOn: for examples.!

!WATextAreaTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
columns: anInteger 
	"This attribute specifies the visible width in average character widths. User agents may wrap visible text lines to keep long lines visible without the need for scrolling."
	self attributes 
		at: 'cols'
		put: anInteger! !

!WATextAreaTag methodsFor: 'initialization' stamp: 'lr 2/16/2008 18:42'!
initialize
	super initialize.
	self rows: 'auto'; columns: 'auto'! !

!WATextAreaTag methodsFor: 'testing' stamp: 'lr 3/26/2007 21:12'!
isClosed
	^ false! !

!WATextAreaTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
rows: anInteger 
	"This attribute specifies the number of visible text lines. If more are entered, the widget scrolls."
	self attributes 
		at: 'rows'
		put: anInteger! !

!WATextAreaTag methodsFor: 'accessing' stamp: 'ac 4/13/2005 01:51'!
tag
	^ 'textarea'! !

!WATextAreaTag methodsFor: 'attributes' stamp: 'lr 9/4/2007 15:53'!
value
	^ value! !

!WATextAreaTag methodsFor: 'attributes' stamp: 'ac 8/30/2005 16:26'!
value: aString
	value := aString! !

!WATextAreaTag methodsFor: 'public' stamp: 'lr 9/4/2007 15:57'!
with: aBlock
	super with: (value ifNil: [ aBlock ])! !

WAAbstractTextAreaTag subclass: #WATextInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATextInputTag commentStamp: 'pmm 4/24/2007 11:13' prior: 0!
I am a single line text input widget. See WAInputTest >> #renderTextInputWithExampleOn: for examples.!

WATextInputTag subclass: #WAPasswordInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAPasswordInputTag commentStamp: 'pmm 4/23/2007 21:12' prior: 0!
I am a password input widget that does not display the entered text.!

!WAPasswordInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 17:33'!
type
	^ 'password'! !

!WATextInputTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
maxLength: aNumber 
	"This attribute specifies the maximum number of characters the user may enter. This number may exceed the specified #size:, in which case the user agent should offer a scrolling mechanism. The default value for this attribute is an unlimited number."
	self attributes 
		at: 'maxlength'
		put: aNumber! !

!WATextInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:50'!
type
	^ 'text'! !

!WATextInputTag methodsFor: 'public' stamp: 'jf 9/30/2009 01:10'!
with: anObject 
	anObject isNil ifFalse: [ self value: anObject greaseString ].
	super with: nil! !

WAAbstractTextAreaTag subclass: #WAUrlInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAUrlInputTag commentStamp: 'pmm 3/16/2007 13:37' prior: 0!
supported on:
- Opera 9
graceful degeneration to text input

An IRI, as defined by [RFC3987] (the IRI token, defined in RFC 3987 section 2.2). UAs could, for example, offer the user URIs from his bookmarks. (See below for notes on IDN.) The value is called url (as opposed to iri or uri) for consistency with CSS syntax and because it is generally felt authors are more familiar with the term "URL" than the other, more technically correct terms.!

!WAUrlInputTag methodsFor: 'private' stamp: 'pmm 4/22/2012 16:10'!
allValuesCallbackClass
	^ WAAllUrlsCallback! !

!WAUrlInputTag methodsFor: 'callbacks' stamp: 'pmm 6/14/2009 13:38'!
callback: aBlock
	self name: (self storeCallback: (WAUrlCallback on: aBlock)).
	self value: self value! !

!WAUrlInputTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
type
	^ 'url'! !

WAFormInputTag subclass: #WAButtonTag
	instanceVariableNames: 'type value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAButtonTag commentStamp: 'pmm 7/28/2007 08:54' prior: 0!
Buttons created with the BUTTON element function just like buttons created with the INPUT element, but they offer richer rendering possibilities: the BUTTON element may have content. For example, a BUTTON element that contains an image functions like and may resemble an INPUT element whose type is set to "image", but the BUTTON element type allows content.!

!WAButtonTag methodsFor: 'accessing' stamp: 'pmm 7/28/2007 08:40'!
bePush
	"Creates a push button. Push buttons have no default behavior. Each push button may have client-side scripts associated with the element's event attributes. When an event occurs (e.g., the user presses the button, releases it, etc.), the associated script is triggered."
	type := 'button'! !

!WAButtonTag methodsFor: 'accessing' stamp: 'pmm 7/28/2007 08:34'!
beReset
	"Creates a reset button. When activated it resets all controls to their initial values."
	type := 'reset'! !

!WAButtonTag methodsFor: 'accessing' stamp: 'pmm 7/28/2007 08:33'!
beSubmit
	"Creates a submit button. When activated, a submit button submits a form. A form may contain more than one submit button. This is the default."
	type := 'submit'! !

!WAButtonTag methodsFor: 'callbacks' stamp: 'jf 9/30/2009 00:24'!
callback: aNiladicValuable 
	aNiladicValuable argumentCount > 0 ifTrue: [ GRInvalidArgumentCount signal: 'Buttons expect a niladic callback.' ].
	self name: (self storeCallback: (WAActionCallback on: aNiladicValuable))! !

!WAButtonTag methodsFor: 'initialization' stamp: 'pmm 7/28/2007 08:34'!
initialize
	super initialize.
	self beSubmit! !

!WAButtonTag methodsFor: 'testing' stamp: 'lr 6/13/2007 21:13'!
isClosed
	^ false! !

!WAButtonTag methodsFor: 'callbacks' stamp: 'jf 9/30/2009 00:22'!
on: aSymbol of: anObject 
	self value: (self 
			labelForSelector: aSymbol
			of: anObject).
	self callback: (GRDelayedSend 
			receiver: anObject
			selector: aSymbol)! !

!WAButtonTag methodsFor: 'accessing' stamp: 'lr 6/13/2007 21:13'!
tag
	^ 'button'! !

!WAButtonTag methodsFor: 'accessing' stamp: 'lr 8/8/2007 14:48'!
type
	^ type! !

!WAButtonTag methodsFor: 'attributes' stamp: 'lr 9/18/2007 08:18'!
value
	^ value! !

!WAButtonTag methodsFor: 'attributes' stamp: 'lr 9/18/2007 08:19'!
value: aString
	value := aString! !

!WAButtonTag methodsFor: 'public' stamp: 'lr 9/18/2007 08:19'!
with: aBlock
	super with: (value ifNil: [ aBlock ])! !

WAFormInputTag subclass: #WACheckboxTag
	instanceVariableNames: 'value callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WACheckboxTag commentStamp: 'pmm 9/14/2013 16:00' prior: 0!
The checkbox element is used with an associated property of typ boolean. It renders a HTML <input> element of type checkbox.

If this input element is disabled then the callback will still be evaluated but with an argument that is false. See method comment of #callback: for more information.

!

!WACheckboxTag methodsFor: 'private' stamp: 'lr 2/28/2009 22:42'!
after
	super after.
	callback isNil ifTrue: [ ^ self ].
	canvas hiddenInput 
		callback: [
			callback value: value.
			value := false ]! !

!WACheckboxTag methodsFor: 'callbacks' stamp: 'lr 7/25/2011 19:03'!
callback: aBlock
	"Compared to other form elements this input element is disabled then the callback will still be evaluted but with an argument that is false. So either don't assign a callback to disabled checkboxes or make the callback code aware that he might be invoked in a disabled state.
	
	However if you enable a disabled checkbox with JavaScript then the callback is invoked with the correct argument.
	
	http://code.google.com/p/seaside/issues/detail?id=18"

	value := false.
	callback := aBlock fixCallbackTemps.
	super callback: [ value := true ]! !

!WACheckboxTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
onTrue: trueBlock onFalse: falseBlock
	trueBlock fixCallbackTemps. falseBlock fixCallbackTemps.
	self callback: [ :v | v ifTrue: [ trueBlock value ] ifFalse: [ falseBlock value ] ]! !

!WACheckboxTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:44'!
type
	^ 'checkbox'! !

!WACheckboxTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
value: aBoolean 
	self attributes 
		at: 'checked'
		put: aBoolean! !

WAFormInputTag subclass: #WAFileUploadTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAFileUploadTag commentStamp: 'pmm 4/15/2007 22:22' prior: 0!
I represent a file input element (<input type="file"). My callbacks will be evaluated with an instance of WAFile as an argument.!

!WAFileUploadTag methodsFor: 'attributes' stamp: 'pmm 5/2/2007 21:50'!
accept: aString
	"This attribute specifies a comma-separated list of content types that a server processing this form will handle correctly. User agents may use this information to filter out non-conforming files when prompting a user to select files to be sent to the server"
	self attributes at: 'accept' put: aString! !

!WAFileUploadTag methodsFor: 'attributes' stamp: 'pmm 4/21/2012 20:05'!
beMultiple
	"The multiple attribute is a boolean attribute that indicates whether the user is to be allowed to specify more than one value."
	self attributeAt: 'multiple' put: true! !

!WAFileUploadTag methodsFor: 'callbacks' stamp: 'pmm 9/7/2010 16:19'!
callback: aBlock
	"Only called if a file was selected."
	self name: (self storeCallback: (WAUploadCallback on: aBlock))! !

!WAFileUploadTag methodsFor: 'callbacks' stamp: 'pmm 4/22/2012 16:15'!
multipleValuesCallback: aBlock
	self beMultiple.
	self name: (self storeCallback: (WAAllUploadsCallback on: aBlock))! !

!WAFileUploadTag methodsFor: 'callbacks' stamp: 'jf 9/30/2009 00:22'!
on: aSelector of: anObject 
	self callback: (GRDelayedSend 
			receiver: anObject
			selector: aSelector asMutator)! !

!WAFileUploadTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:45'!
type
	^ 'file'! !

!WAFormInputTag methodsFor: 'callbacks' stamp: 'MAD 2/20/2009 16:11'!
callback: aBlock
	self name: (self storeCallback: (WAValueCallback on: aBlock))! !

!WAFormInputTag methodsFor: 'testing' stamp: 'lr 3/26/2007 21:12'!
isClosed
	^ true! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'pmm 11/11/2008 23:00'!
name: aString
	"This attribute assigns the control name.
	
	A control's 'control name' is given by its name attribute. The scope of the name attribute for a control within a FORM element is the FORM element."
	self attributes at: 'name' put: aString! !

!WAFormInputTag methodsFor: 'callbacks' stamp: 'jf 9/30/2009 00:22'!
on: aSelector of: anObject 
	self value: (anObject perform: aSelector).
	self callback: (GRDelayedSend 
			receiver: anObject
			selector: aSelector asMutator)! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'pmm 4/23/2007 21:24'!
readonly: aBoolean
	"When set to true, this boolean attribute prohibits changes to the widget."
	self attributes at: 'readonly' put: aBoolean! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'MAD 2/20/2009 18:03'!
size: aNumber 
	"This attribute tells the user agent the initial width of the widget. The width is given in pixels except when type attribute has the value 'text' or 'password'. In that case, its value refers to the (integer) number of characters."
	self attributes 
		at: 'size'
		put: aNumber! !

!WAFormInputTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 12:08'!
tag
	^ 'input'! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:37'!
text: aString
	self value: aString! !

!WAFormInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:43'!
type
	^ nil! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:34'!
type: aString
	self attributes at: 'type' put: aString! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:34'!
value
	^ self attributes at: 'value'! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 2/28/2009 22:44'!
value: anObject
	anObject isNil
		ifFalse: [ self attributes at: 'value' put: anObject ]! !

!WAFormInputTag methodsFor: 'public' stamp: 'lr 11/16/2006 15:31'!
with: aBlock
	self type isNil ifFalse: [
		self attributes at: 'type' ifAbsentPut: [ self type ].
		self class: self type ].
	super with: aBlock! !

WAFormInputTag subclass: #WAHiddenInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAHiddenInputTag commentStamp: 'pmm 9/22/2007 22:23' prior: 0!
Authors may create controls that are not rendered but whose values are submitted with a form. Authors generally use this control type to store information between client/server exchanges that would otherwise be lost due to the stateless nature of HTTP (see [RFC2616]). The INPUT element is used to create a hidden control.!

!WAHiddenInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 17:45'!
type
	^ 'hidden'! !

WAFormInputTag subclass: #WARadioButtonTag
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WARadioButtonTag commentStamp: '<historical>' prior: 0!
Radio buttons work like checkboxes. The difference is that radio buttons, when sharing a single control name, are exclusive. This means that only one of those radio buttons can be checked, and when it's checked, the rest are automatically unchecked.

Radio buttons must be created through a radio group. The callback is only called for the selected option.

| group |
group := html radioGroup.
group radioButton
	selected: aBoolean;
	callback: [ self someThing ]!

!WARadioButtonTag methodsFor: 'attributes' stamp: 'TestRunner 1/25/2010 11:02'!
beChecked
	self selected: true! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'TestRunner 1/25/2010 11:03'!
beUnchecked
	self selected: false! !

!WARadioButtonTag methodsFor: 'callbacks' stamp: 'lr 9/5/2010 22:18'!
callback: aBlock
	"Only called if option was selected."
	
	self attributes at: 'value' put: (self storeCallback: (WAValueCallback on: aBlock))! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'TestRunner 1/25/2010 11:05'!
checked: aBoolean
	self attributes 
		at: 'checked'
		put: aBoolean! !

!WARadioButtonTag methodsFor: 'accessing' stamp: 'TestRunner 1/25/2010 11:02'!
group
	^ group! !

!WARadioButtonTag methodsFor: 'accessing' stamp: 'obi 12/31/2009 13:22'!
group: aRadioGroup
	self name: aRadioGroup key.
	group := aRadioGroup! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'TestRunner 1/25/2010 11:05'!
selected: aBoolean 
	self checked: aBoolean! !

!WARadioButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:46'!
type
	^ 'radio'! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'TestRunner 1/25/2010 11:01'!
value: anObject
	group isNil
		ifTrue: [ ^ super value: anObject ].
	group hasSelection 
		ifTrue: [ self selected: (group isSelected: anObject) ].
	group hasCallback 
		ifTrue: [ super value: (group callbackValue: anObject) ]! !

WAFormInputTag subclass: #WASubmitButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WASubmitButtonTag commentStamp: 'obi 4/2/2008 22:58' prior: 0!
The submit type creates a button. When a submit button is pressed it automatically submits the form.!

WASubmitButtonTag subclass: #WACancelButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WACancelButtonTag methodsFor: 'callbacks' stamp: 'MAD 2/20/2009 15:18'!
callback: aBlock
	self name: (self storeCallback: (WACancelActionCallback on: aBlock))! !

WASubmitButtonTag subclass: #WAImageButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAImageButtonTag commentStamp: 'pmm 7/28/2007 08:56' prior: 0!
Creates a graphical submit button. The value of the src attribute specifies the URI of the image that will decorate the button. For accessibility reasons, authors should provide alternate text for the image via the alt attribute. 

When a pointing device is used to click on the image, the form is submitted and the click coordinates passed to the server. The x value is measured in pixels from the left of the image, and the y value in pixels from the top of the image. The submitted data includes name.x=x-value and name.y=y-value where "name" is the value of the name attribute, and x-value and y-value are the x and y coordinate values, respectively.!

!WAImageButtonTag methodsFor: 'callbacks' stamp: 'MAD 2/20/2009 15:43'!
callback: aBlock
	self name: (self storeCallback: (WAImageCallback on: aBlock))! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:33'!
extent: aPoint
	self width: aPoint x; height: aPoint y! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:43'!
height: aNumber
	self attributes at: 'height' put: aNumber! !

!WAImageButtonTag methodsFor: 'accessing' stamp: 'jf 2/21/2009 18:29'!
resourceUrl: aString
	self url: (canvas absoluteUrlForResource: aString)! !

!WAImageButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:49'!
type
	^ 'image'! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:33'!
url: aString
	self attributes at: 'src' put: aString! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:43'!
width: aNumber
	self attributes at: 'width' put: aNumber! !

!WASubmitButtonTag methodsFor: 'callbacks' stamp: 'jf 9/30/2009 00:24'!
callback: aNiladicValuable 
	aNiladicValuable argumentCount > 0 ifTrue: 
		[ GRInvalidArgumentCount signal: 'Submit buttons expect a niladic callback.' ].
	self name: (self storeCallback: (WAActionCallback on: aNiladicValuable))! !

!WASubmitButtonTag methodsFor: 'callbacks' stamp: 'jf 9/30/2009 00:22'!
on: aSymbol of: anObject 
	self value: (self 
			labelForSelector: aSymbol
			of: anObject).
	self callback: (GRDelayedSend 
			receiver: anObject
			selector: aSymbol)! !

!WASubmitButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:49'!
type
	^ 'submit'! !

!WASubmitButtonTag methodsFor: 'public' stamp: 'jf 9/30/2009 01:10'!
with: anObject 
	anObject isNil ifFalse: [ self value: anObject greaseString ].
	super with: nil! !

WATagBrush subclass: #WAGenericTag
	instanceVariableNames: 'tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WAGenericTag commentStamp: 'pmm 6/1/2008 00:40' prior: 0!
A WAGenericTag is the class for all tags that do not have a class of their own.

Instance Variables
	tag:		<String>

tag
	- the name of the tag
!

WAGenericTag subclass: #WAEditTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAEditTag commentStamp: 'pmm 3/28/2007 10:40' prior: 0!
INS and DEL are used to markup sections of the document that have been inserted or deleted with respect to a different version of a document (e.g., in draft legislation where lawmakers need to view the changes).

These two elements are unusual for HTML in that they may serve as either block-level or inline elements (but not both). They may contain one or more words within a paragraph or contain one or more block-level elements such as paragraphs, lists and tables.

This example could be from a bill to change the legislation for how many deputies a County Sheriff can employ from 3 to 5.

<P>
  A Sheriff can employ <DEL>3</DEL><INS>5</INS> deputies.
</P>

The INS and DEL elements must not contain block-level content when these elements behave as inline elements.!

!WAEditTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
cite: aUrl 
	"The value of this attribute is a URI that designates a source document or message. This attribute is intended to point to information explaining why a document was changed."
	self attributes 
		at: 'cite'
		put: aUrl! !

!WAEditTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
datetime: anObject 
	"The value of this attribute specifies the date and time when the change was made.
	ISO date format"
	self attributes 
		at: 'datetime'
		put: anObject! !

!WAGenericTag class methodsFor: 'instance creation' stamp: 'jf 3/13/2009 18:13'!
tag: aString
	^ self basicNew initializeWithTag: aString; yourself! !

!WAGenericTag methodsFor: 'initialization' stamp: 'jf 3/13/2009 18:13'!
initializeWithTag: aString
	self initialize.
	tag := aString! !

!WAGenericTag methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:40'!
tag
	^ tag! !

WATagBrush subclass: #WAHeadingTag
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAHeadingTag commentStamp: 'pmm 6/30/2007 00:44' prior: 0!
A heading element briefly describes the topic of the section it introduces. Heading information may be used by user agents, for example, to construct a table of contents for a document automatically.

There are six levels of headings in HTML with H1 as the most important and H6 as the least. Visual browsers usually render more important headings in larger fonts than less important ones.!

!WAHeadingTag methodsFor: 'initialization' stamp: 'lr 6/6/2007 14:02'!
initialize
	super initialize.
	self level1! !

!WAHeadingTag methodsFor: 'accessing' stamp: 'lr 4/9/2007 18:26'!
level
	^ level! !

!WAHeadingTag methodsFor: 'convenience' stamp: 'lr 6/6/2007 14:02'!
level1
	level := 1! !

!WAHeadingTag methodsFor: 'convenience' stamp: 'lr 6/6/2007 14:02'!
level2
	level := 2! !

!WAHeadingTag methodsFor: 'convenience' stamp: 'lr 6/6/2007 14:02'!
level3
	level := 3! !

!WAHeadingTag methodsFor: 'convenience' stamp: 'lr 6/6/2007 14:02'!
level4
	level := 4! !

!WAHeadingTag methodsFor: 'convenience' stamp: 'lr 6/6/2007 14:02'!
level5
	level := 5! !

!WAHeadingTag methodsFor: 'convenience' stamp: 'lr 6/6/2007 14:02'!
level6
	level := 6! !

!WAHeadingTag methodsFor: 'accessing' stamp: 'lr 6/6/2007 14:01'!
level: anInteger
	level := (anInteger max: 1) min: 6! !

!WAHeadingTag methodsFor: 'accessing' stamp: 'jf 9/30/2009 01:10'!
tag
	^ 'h' , self level greaseString! !

WATagBrush subclass: #WAHorizontalRuleTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAHorizontalRuleTag commentStamp: 'pmm 9/22/2007 22:24' prior: 0!
The HR element causes a horizontal rule to be rendered by visual user agents.

The amount of vertical space inserted between a rule and the content that surrounds it depends on the user agent.!

!WAHorizontalRuleTag methodsFor: 'testing' stamp: 'lr 3/26/2007 21:10'!
isClosed
	^ true! !

!WAHorizontalRuleTag methodsFor: 'accessing' stamp: 'lr 3/26/2007 21:08'!
tag
	^ 'hr'! !

WATagBrush subclass: #WAIframeTag
	instanceVariableNames: 'rootBlock url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAIframeTag commentStamp: 'pmm 9/22/2007 22:25' prior: 0!
The IFRAME element allows authors to insert a frame within a block of text. Inserting an inline frame within a section of text is much like inserting an object via the OBJECT element: they both allow you to insert an HTML document in the middle of another, they may both be aligned with surrounding text, etc. 

The information to be inserted inline is designated by the src attribute of this element. The contents of the IFRAME element, on the other hand, should only be displayed by user agents that do not support frames or are configured not to display frames.

Inline frames may not be resized.!

!WAIframeTag methodsFor: 'callbacks' stamp: 'pmm 8/23/2011 11:59'!
callback: aNiladicValuable
	"Evalautes the given valuable when the content of the iframe is loaded.
	You probably want to switch the presenter of the switch the presenter of the session. See WAIframeFunctionalTest for an example.
	In Seaside 3.1 this may be replaced by a dedicated continuation."
	aNiladicValuable argumentCount > 0 ifTrue: [ GRInvalidArgumentCount signal: 'Iframes expect a niladic callback.' ].
	self url addField: (self storeCallback: (WAActionCallback on: aNiladicValuable))! !

!WAIframeTag methodsFor: 'convenience' stamp: 'pmm 5/23/2007 19:05'!
contents: anObject
	self url: (canvas urlForAction: [ self performRendering: anObject ])! !

!WAIframeTag methodsFor: 'attributes' stamp: 'pmm 9/22/2007 22:26'!
height: anInteger
	"The height of the inline frame."
	self attributes at: 'height' put: anInteger! !

!WAIframeTag methodsFor: 'attributes' stamp: 'pmm 9/22/2007 22:26'!
name: aString
	"This attribute assigns a name to the current frame. This name may be used as the target of subsequent links."
	self attributes at: 'name' put: aString! !

!WAIframeTag methodsFor: 'private' stamp: 'pmm 8/23/2011 10:05'!
performRendering: anObject
	| innerContext docRoot document renderer |
	self requestContext respond: [ :response |
		innerContext := canvas context copy.
		docRoot := WAHtmlRoot context: innerContext.
		response contentType: WAMimeType textHtml.
		response doNotCache.
		self rootBlock value: docRoot.
		document := self requestContext handler documentClass 
			on: response stream codec: self requestContext codec.
		canvas context document: document.
		document open: docRoot.
		renderer := canvas species context: canvas context.
		renderer render: anObject; flush.
		document close ]! !

!WAIframeTag methodsFor: 'accessing' stamp: 'pmm 1/31/2010 14:37'!
rootBlock
	"Anser the block to render the HTML root."
	^ rootBlock isNil
		ifTrue: [ [ :root | root base target: '_top' ] ]
		ifFalse: [ rootBlock ]! !

!WAIframeTag methodsFor: 'accessing' stamp: 'pmm 1/31/2010 14:38'!
rootBlock: aOneArgumentBlock
	"Set the block hat is used to render the html <head> element. An instance of WAHtmlRoot will be passed as an argument. You'll probably want to add:
		root base target: '_top' 
	to your block."
	rootBlock := aOneArgumentBlock! !

!WAIframeTag methodsFor: 'accessing' stamp: 'lr 3/8/2006 23:25'!
tag
	^ 'iframe'! !

!WAIframeTag methodsFor: 'attributes' stamp: 'pmm 8/23/2011 09:26'!
url
	^ url ifNil: [ url := canvas actionUrl copy ]! !

!WAIframeTag methodsFor: 'attributes' stamp: 'pmm 8/23/2011 09:27'!
url: aUrlOrString 
	url := aUrlOrString! !

!WAIframeTag methodsFor: 'attributes' stamp: 'pmm 9/22/2007 22:26'!
width: anInteger
	"The width of the inline frame."
	self attributes at: 'width' put: anInteger! !

!WAIframeTag methodsFor: 'public' stamp: 'pmm 8/23/2011 09:29'!
with: aBlock
	url isNil
		ifFalse: [ self attributes at: 'src' put: url ].
	super with: aBlock! !

WATagBrush subclass: #WAImageTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAImageTag commentStamp: 'pmm 9/22/2007 22:28' prior: 0!
The IMG element embeds an image in the current document at the location of the element's definition. The IMG element has no content; it is usually replaced inline by the image designated by the src attribute, the exception being for left or right-aligned images that are "floated" out of line.

The alt attribute specifies alternate text that is rendered when the image cannot be displayed (see below for information on how to specify alternate text ). User agents must render alternate text when they cannot support images, they cannot support a certain image type or when they are configured not to display images.

Seaside per default sets the alternate text to an empty string. This helps validation of the page.!

!WAImageTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
altText: aString
	"The alt attribute provides a short description of the image."
	self attributes at: 'alt' put: aString! !

!WAImageTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
height: anInteger
	self attributes at: 'height' put: anInteger! !

!WAImageTag methodsFor: 'initialization' stamp: 'lr 6/20/2007 10:53'!
initialize
	super initialize.
	self altText: ''! !

!WAImageTag methodsFor: 'testing' stamp: 'lr 3/27/2007 11:06'!
isClosed
	^ true! !

!WAImageTag methodsFor: 'accessing' stamp: 'jf 2/21/2009 18:29'!
resourceUrl: aString
	self url: (canvas absoluteUrlForResource: aString)! !

!WAImageTag methodsFor: 'initialization' stamp: 'lr 3/24/2008 13:01'!
setParent: aBrush canvas: aCanvas 
	super 
		setParent: aBrush
		canvas: aCanvas.
	(aBrush isKindOf: WAImageMapTag) ifTrue: [ 
		"in case the parent is an image map we need to set this attribute"
		self attributes 
			at: 'ismap'
			put: true ]! !

!WAImageTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 12:00'!
tag
	^ 'img'! !

!WAImageTag methodsFor: 'attributes' stamp: 'lr 6/20/2007 10:53'!
url: aString
	self attributes at: 'src' put: aString! !

!WAImageTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
width: anInteger
	self attributes at: 'width' put: anInteger! !

WATagBrush subclass: #WAKeyGeneratorTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAKeyGeneratorTag commentStamp: 'pmm 11/11/2008 22:49' prior: 0!
A WAKeygenTag is allows the user agent to generate a secure key and submits the public key.

Supported by:
    * Netscape 3, 4, 6, 7
    * Mozilla 1
    * Firefox 1
    * Opera 3, 4, 5, 6, 7, 8
    * Safari 1 

=== Links for more info ===
http://lists.whatwg.org/pipermail/whatwg-whatwg.org/attachments/20080714/07ea5534/attachment.txt
http://wp.netscape.com/eng/security/comm4-keygen.html
http://wp.netscape.com/eng/security/ca-interface.html
http://webdesign.about.com/od/htmltags/p/bltags_keygen.htm
http://eskimonorth.com/~bloo/indexdot/html/tagpages/k/keygen.htm
http://web.archive.org/web/20040710102131/devedge.netscape.com/library/manuals/1998/htmlguide/
http://64.233.183.104/search?q=cache:TExfCslqOcwJ:www.html4newbies.com/Keygen.php
http://www.di.unito.it/~rabser/ssleay/x509_netscape.html
http://msdn.microsoft.com/en-us/library/cc214558.aspx - Something that may look like the MS version of the keygen attribute
!

!WAKeyGeneratorTag methodsFor: 'callbacks' stamp: 'MAD 2/20/2009 16:13'!
callback: aBlock
	self name: (self storeCallback: (WAValueCallback on: aBlock))! !

!WAKeyGeneratorTag methodsFor: 'attributes' stamp: 'pmm 11/11/2008 22:52'!
challenge: aString
	"Specifies the challenge string to be packaged with the public key for use in verification of the form submission. If no challenge string is provided, then it is encoded as an 'IA5STRING' of length zero. "
	self attributeAt: 'challenge' put: aString! !

!WAKeyGeneratorTag methodsFor: 'testing' stamp: 'lr 7/25/2011 20:11'!
isClosed
	^ true! !

!WAKeyGeneratorTag methodsFor: 'attributes' stamp: 'pmm 11/11/2008 22:53'!
keyType: aString
	"This attribute specifies the type of encryption security method to use to verify the receiver. 
    Values: 'RSA' (default) or 'DSA'"
	self attributeAt: 'keytype' put: aString! !

!WAKeyGeneratorTag methodsFor: 'attributes' stamp: 'pmm 11/11/2008 23:10'!
name: aString
	"The same as WAFormInputTag >> #name:"
	self attributeAt: 'name' put: aString! !

!WAKeyGeneratorTag methodsFor: 'attributes' stamp: 'pmm 11/11/2008 22:55'!
pqg: aString
	"This attribute appears to be a security string to be sent and verified."
	self attributeAt: 'pqg' put: aString! !

!WAKeyGeneratorTag methodsFor: 'accessing' stamp: 'pmm 11/11/2008 23:05'!
tag
	^ 'keygen'! !

WATagBrush subclass: #WALabelTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WALabelTag commentStamp: 'obi 4/2/2008 22:38' prior: 0!
Defines a label to a control. If you click the text within the label element,  it is supposed to toggle the control.!

!WALabelTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
for: aString 
	self attributes 
		at: 'for'
		put: aString! !

!WALabelTag methodsFor: 'accessing' stamp: 'ac 7/9/2005 04:36'!
tag
	^ 'label'! !

WATagBrush subclass: #WAMediaElementTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAMediaElementTag commentStamp: 'as 2/8/2011 14:42' prior: 0!
WAMediaElementTag is an abstract class for all the media elements providing common media attributes.
See: http://www.w3.org/TR/html5/video.html#media-element!

WAMediaElementTag subclass: #WAAudioTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAAudioTag commentStamp: 'pmm 3/28/2007 22:54' prior: 0!
no known browser support, might require an open codec like Ogg Vorbis, might first appear in Opera and Mozilla

An audio element represents a sound or audio stream.

Content may be provided inside the audio element so that older Web browsers, which do not support audio, can display text to the user informing them of how to access the audio contents. User agents should not show this fallback content to the user. !

!WAAudioTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
tag
	^ 'audio'! !

!WAMediaElementTag methodsFor: 'attributes' stamp: 'pmm 9/1/2012 16:30'!
autoplay: aBoolean
	"The autoplay attribute is a boolean attribute. When present, the user agent (as described in the algorithm described herein) will automatically begin playback of the media resource as soon as it can do so without stopping."
	self attributeAt: 'autoplay' put: aBoolean! !

!WAMediaElementTag methodsFor: 'attributes' stamp: 'pmm 9/1/2012 16:30'!
controls: aBoolean
	"The controls attribute is a boolean attribute. If present, it indicates that the author has not provided a scripted controller and would like the user agent to provide its own set of controls."
	self attributeAt: 'controls' put: aBoolean! !

!WAMediaElementTag methodsFor: 'attributes' stamp: 'pmm 9/1/2012 16:30'!
loop: aBoolean
	"The loop attribute is a boolean attribute that, if specified, indicates that the media element is to seek back to the start of the media resource upon reaching the end."
	self attributeAt: 'loop' put: aBoolean! !

!WAMediaElementTag methodsFor: 'attributes' stamp: 'pmm 9/1/2012 16:30'!
preload: aString
	"The preload attribute is intended to provide a hint to the user agent about what the author thinks will lead to the best user experience.
	See: http://www.w3.org/TR/html5/video.html#attr-media-preload
	
	The preload attribute can have one of three values: 'none', 'metadata', 'auto'.
	Providing an empty string defaults the value of the attribute to be 'auto'."
	self attributeAt: 'preload' put: aString! !

!WAMediaElementTag methodsFor: 'attributes' stamp: 'as 2/8/2011 14:26'!
url: aString
	self attributeAt: 'src' put: aString! !

WAMediaElementTag subclass: #WAVideoTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAVideoTag commentStamp: 'pmm 4/4/2007 03:01' prior: 0!
Supported only on experimental Opera
http://people.opera.com/howcome/2007/video/

A video element represents a video or movie, with an alternate representation given by its contents.

http://www.whatwg.org/specs/web-apps/current-work/#video
http://lists.whatwg.org/pipermail/whatwg-whatwg.org/attachments/20070228/6a0cdddc/attachment.txt!

!WAVideoTag methodsFor: 'attributes' stamp: 'pmm 3/18/2007 12:57'!
height: anInteger
	"The videoHeight  DOM attribute must return the native height of the video in CSS pixels. In the absence of resolution information, user agents may assume that one pixel in the video corresponds to one CSS pixel."
	self attributeAt: 'height' put: anInteger! !

!WAVideoTag methodsFor: 'attributes' stamp: 'pmm 9/1/2012 16:31'!
poster: aString
	"The poster attribute gives the address of an image file that the user agent can show while no video data is available. The attribute, if present, must contain a valid non-empty URL potentially surrounded by spaces."
	self attributeAt: 'poster' put: aString! !

!WAVideoTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
tag
	^ 'video'! !

!WAVideoTag methodsFor: 'attributes' stamp: 'pmm 3/18/2007 12:57'!
width: anInteger
	"The videoWidth DOM attribute must return the native width of the video in CSS pixels. In the absence of resolution information, user agents may assume that one pixel in the video corresponds to one CSS pixel."
	self attributeAt: 'width' put: anInteger! !

WATagBrush subclass: #WAMenuTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAMenuTag commentStamp: 'pmm 3/31/2007 01:10' prior: 0!
no known browser support

The menu element represents a list of commands.

The type attribute indicates the kind of menu. It must have either the value popup (to declare a context menu) or the value toolbar (to define a tool bar). The attribute may also be omitted, to indicate that the element is merely a list of commands that is neither declaring a context menu nor defining a tool bar.

If a menu element has a type attribute with the value popup, then it represents the commands of a context menu, and the user can only interact with the commands if that context menu is activated.

If a menu element has a type attribute with the value toolbar, then it represents a list of active commands that the user can immediately interact with.

Otherwise, if a menu element has no type attribute, or if has a type attribute with a value other than popup or toolbar, then it either represents an unordered list of items (each represented by an li element), each of which represents a command that the user may perform or activate, or, if the element has no li element children, a paragraph describing available commands.

The label attribute gives the label of the menu. It is used by user agents to display nested menus in the UI. For example, a context menu containing another menu would use the nested menu's label attribute for the submenu's menu label.

The autosubmit attribute is a boolean attribute that, if present, indicates that selections made to form controls in this menu are to result in the control's form being immediately submitted. !

!WAMenuTag methodsFor: 'attributes' stamp: 'pmm 3/31/2007 01:12'!
autosubmit
	"The autosubmit attribute is a boolean attribute that, if present, indicates that selections made to form controls in this menu are to result in the control's form being immediately submitted."
	self attributeAt: 'autosubmit' put: true! !

!WAMenuTag methodsFor: 'type' stamp: 'pmm 3/31/2007 01:11'!
bePopup
	self type: 'popup'! !

!WAMenuTag methodsFor: 'type' stamp: 'pmm 3/31/2007 01:12'!
beToolbar
	self type: 'toolbar'! !

!WAMenuTag methodsFor: 'attributes' stamp: 'pmm 3/31/2007 01:12'!
label: aString
	"The label  attribute gives the label of the menu. It is used by user agents to display nested menus in the UI. For example, a context menu containing another menu would use the nested menu's label attribute for the submenu's menu label."
	self attributeAt: 'label' put: aString! !

!WAMenuTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
tag
	^ 'menu'! !

!WAMenuTag methodsFor: 'attributes' stamp: 'pmm 3/31/2007 01:11'!
type: aString
	"The type  attribute indicates the kind of menu. It must have either the value popup (to declare a context menu) or the value toolbar (to define a tool bar). The attribute may also be omitted, to indicate that the element is merely a list of commands that is neither declaring a context menu nor defining a tool bar."
	self attributeAt: 'type' put: aString! !

WATagBrush subclass: #WAMeterTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAMeterTag commentStamp: 'pmm 3/28/2007 22:34' prior: 0!
No known browser support.

The meter element represents a scalar measurement within a known range, or a fractional value; for example disk usage, the relevance of a query result, or the fraction of a voting population to have selected a particular candidate.

This is also known as a gauge.

The meter element should not be used to indicate progress (as in a progress bar). For that role, HTML provides a separate progress element.

There are six attributes that determine the semantics of the gauge represented by the element.

The min attribute specifies the lower bound of the range, and the max attribute specifies the upper bound. The value attribute specifies the value to have the gauge indicate as the "measured" value.

The other three attributes can be used to segment the gauge's range into "low", "medium", and "high" parts, and to indicate which part of the gauge is the "optimum" part. The low attribute specifies the range that is considered to be the "low" part, and the high attribute specifies the range that is considered to be the "high" part. The optimum attribute gives the position that is "optimum"; if that is higher than the "high" value then this indicates that the higher the value, the better; if it's lower than the "low" mark then it indicates that lower values are better, and naturally if it is in between then it indicates that neither high nor low values are good.

The value, min, low, high, max, and optimum attributes are all optional. When present, they must have values that are valid floating point numbers.

The following examples all represent a measurement of three quarters (of the maximum of whatever is being measured):

<meter>75%</meter>
<meter>750\u2030</meter>
<meter>3/4</meter>
<meter>6 blocks used (out of 8 total)</meter>
<meter>max: 100; current: 75</meter>
<meter><object data="graph75.png">0.75</object></meter>
<meter min="0" max="100" value="75"></meter>

!

!WAMeterTag methodsFor: 'attributes' stamp: 'pmm 3/28/2007 22:35'!
high: anInteger
	"The high attribute specifies the range that is considered to be the 'high' part."
	self attributeAt: 'high' put: anInteger! !

!WAMeterTag methodsFor: 'attributes' stamp: 'pmm 3/28/2007 22:34'!
low: anInteger
	"The low attribute specifies the range that is considered to be the 'low' part."
	self attributeAt: 'low' put: anInteger! !

!WAMeterTag methodsFor: 'attributes' stamp: 'pmm 3/28/2007 22:31'!
max: anInteger
	"The the max attribute specifies the upper bound of the range."
	self attributeAt: 'max' put: anInteger! !

!WAMeterTag methodsFor: 'attributes' stamp: 'pmm 3/28/2007 22:31'!
min: anInteger
	"The min attribute specifies the lower bound of the range."
	self attributeAt: 'min' put: anInteger! !

!WAMeterTag methodsFor: 'attributes' stamp: 'pmm 3/28/2007 22:35'!
optimum: anInteger
	"The optimum attribute gives the position that is 'optimum'; if that is higher than the 'high' value then this indicates that the higher the value, the better; if it's lower than the 'low' mark then it indicates that lower values are better, and naturally if it is in between then it indicates that neither high nor low values are good."
	self attributeAt: 'optimum' put: anInteger! !

!WAMeterTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
tag
	^ 'meter'! !

!WAMeterTag methodsFor: 'attributes' stamp: 'pmm 3/28/2007 22:32'!
value: anInteger
	"The value  attribute specifies the value to have the gauge indicate as the 'measured' value."
	self attributeAt: 'value' put: anInteger! !

WATagBrush subclass: #WAObjectTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAObjectTag commentStamp: 'obi 4/2/2008 22:46' prior: 0!
Defines an embedded object. Use this element to add multimedia to your XHTML page.
This element allows you to specify the data and parameters for objects inserted into HTML documents, and the code that can be used to display/manipulate that data.!

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
archive: aUrl 
	self attributes 
		at: 'archive'
		put: aUrl! !

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
classId: aUrl 
	self attributes 
		at: 'classid'
		put: aUrl! !

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
codebase: aUrl 
	self attributes 
		at: 'codebase'
		put: aUrl! !

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
codetype: aString 
	self attributes 
		at: 'codetype'
		put: aString! !

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
declare: aBoolean 
	self attributes 
		at: 'declare'
		put: aBoolean! !

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
height: anInteger 
	self attributes 
		at: 'height'
		put: anInteger! !

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
standby: aString 
	self attributes 
		at: 'standby'
		put: aString! !

!WAObjectTag methodsFor: 'accessing' stamp: 'pmm 2/11/2007 19:24'!
tag
	^ 'object'! !

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
type: aString 
	self attributes 
		at: 'type'
		put: aString! !

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
url: aUrl 
	self attributes 
		at: 'data'
		put: aUrl! !

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
width: anInteger 
	self attributes 
		at: 'width'
		put: anInteger! !

WATagBrush subclass: #WAOptionGroupTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAOptionGroupTag commentStamp: 'pmm 4/24/2007 10:53' prior: 0!
The OPTGROUP element allows authors to group choices logically. This is particularly helpful when the user must choose from a long list of options; groups of related choices are easier to grasp and remember than a single long list of options.

It has crappy browser support and noone as ever used it. See WAInputTest >> #renderOptionGroupOn: for examples.!

!WAOptionGroupTag methodsFor: 'initialization' stamp: 'lr 2/16/2008 18:14'!
initialize
	super initialize.
	self label: ''! !

!WAOptionGroupTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
label: aString
	"This attribute specifies the label for the option group."

	self attributes at: 'label' put: aString! !

!WAOptionGroupTag methodsFor: 'accessing' stamp: 'pmm 4/24/2007 10:49'!
tag
	^ 'optgroup'! !

WATagBrush subclass: #WAOptionTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAOptionTag commentStamp: 'obi 4/2/2008 22:45' prior: 0!
The option element defines an option in a drop-down list. !

!WAOptionTag methodsFor: 'callbacks' stamp: 'MAD 2/20/2009 16:14'!
callback: aBlock
	self value: (self storeCallback: (WAValueCallback on: aBlock))! !

!WAOptionTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
label: aString
	"This attribute allows authors to specify a shorter label for an option than the content of the OPTION element. When specified, user agents should use the value of this attribute rather than the content of the OPTION element as the option label."

	self attributes at: 'label' put: aString! !

!WAOptionTag methodsFor: 'attributes' stamp: 'lr 6/6/2007 19:42'!
selected: aBoolean
	self attributes at: 'selected' put: aBoolean! !

!WAOptionTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 17:13'!
tag
	^ 'option'! !

!WAOptionTag methodsFor: 'attributes' stamp: 'lr 6/6/2007 19:42'!
value: aString
	self attributes at: 'value' put: aString! !

!WAOptionTag methodsFor: 'attributes' stamp: 'obi 1/1/2010 10:02'!
value: anObject with: aListTag
	self selected: (aListTag isSelected: anObject).
	self value: (aListTag valueFor: anObject)
	! !

WATagBrush subclass: #WAOptionalBreakTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAOptionalBreakTag methodsFor: 'testing' stamp: 'as 1/30/2011 04:48'!
isClosed
	^ true! !

!WAOptionalBreakTag methodsFor: 'accessing' stamp: 'as 1/30/2011 04:48'!
tag
	^ 'wbr'! !

WATagBrush subclass: #WAOutputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAOutputTag commentStamp: 'pmm 9/28/2011 19:17' prior: 0!
The output element represents the result of a calculation.!

!WAOutputTag methodsFor: 'attributes' stamp: 'as 2/1/2011 17:23'!
for: aString
	"The for content attribute allows an explicit relationship to be made between the result of a calculation and the elements that represent the values that went into the calculation or that otherwise influenced the calculation. The for attribute, if specified, must contain a string consisting of an unordered set of unique space-separated tokens that are case-sensitive, each of which must have the value of an ID of an element in the same Document."
	self attributeAt: 'for' put: aString! !

!WAOutputTag methodsFor: 'attributes' stamp: 'as 2/1/2011 17:24'!
form: aString
	"The form attribute is used to explicitly associate the output element with its form owner."
	self attributeAt: 'form' put: aString! !

!WAOutputTag methodsFor: 'attributes' stamp: 'as 2/1/2011 17:25'!
name: aString
	self attributeAt: 'name' put: aString! !

!WAOutputTag methodsFor: 'accessing' stamp: 'as 2/1/2011 17:22'!
tag
	^ 'output'! !

WATagBrush subclass: #WAParameterTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAParameterTag commentStamp: 'obi 4/2/2008 22:45' prior: 0!
The param element allows you to specify the run-time settings for an object inserted into XHTML documents.!

!WAParameterTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
name: aString 
	self attributes 
		at: 'name'
		put: aString! !

!WAParameterTag methodsFor: 'accessing' stamp: 'pmm 2/11/2007 20:12'!
tag
	^ 'param'! !

!WAParameterTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
type: aString 
	self attributes 
		at: 'type'
		put: aString! !

!WAParameterTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
value: aString 
	self attributes 
		at: 'value'
		put: aString! !

WATagBrush subclass: #WAProgressTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAProgressTag commentStamp: 'pmm 3/28/2007 22:40' prior: 0!
No known browser support.

The progress element represents the completion progress of a task. The progress is either indeterminate, indicating that progress is being made but that it is not clear how much more work remains to be done before the task is complete (e.g. because the task is waiting for a remote host to respond), or the progress is a number in the range zero to a maximum, giving the fraction of work that has so far been completed.

There are two attributes that determine the current task completion represented by the element.

The value attribute specifies how much of the task has been completed, and the max attribute specifies how much work the task requires in total. The units are arbitrary and not specified.

Instead of using the attributes, authors are recommended to simply include the current value and the maximum value inline as text inside the element.

!

!WAProgressTag methodsFor: 'attributes' stamp: 'pmm 3/28/2007 22:41'!
max: anInteger
	"The max attribute specifies how much work the task requires in total"
	self attributeAt: 'max' put: anInteger! !

!WAProgressTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
tag
	^ 'progress'! !

!WAProgressTag methodsFor: 'attributes' stamp: 'pmm 3/28/2007 22:41'!
value: anInteger
	"The value  attribute specifies how much of the task has been completed."
	self attributeAt: 'value' put: anInteger! !

WATagBrush subclass: #WARubyTextTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WARubyTextTag commentStamp: 'obi 4/2/2008 22:50' prior: 0!
This element works with the <ruby> element. 
The text following <rt> appears as a note to the base text displayed by the 
<ruby> element.!

!WARubyTextTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
span: anInteger 
	self attributes 
		at: 'rbspan'
		put: anInteger! !

!WARubyTextTag methodsFor: 'accessing' stamp: 'pmm 9/18/2006 19:00'!
tag
	^ 'rt'! !

WATagBrush subclass: #WAScriptTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAScriptTag commentStamp: 'obi 4/2/2008 22:51' prior: 0!
Defines a script, such as a JavaScript.!

!WAScriptTag methodsFor: 'private' stamp: 'lr 11/11/2008 22:59'!
after
	super after.
	self document nextPutAll: '/*]]>*/'! !

!WAScriptTag methodsFor: 'private' stamp: 'lr 11/11/2008 22:59'!
before
	super before.
	self document nextPutAll: '/*<!![CDATA[*/'! !

!WAScriptTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
defer
	"When set, this boolean attribute provides a hint to the user agent that the script is not going to generate any document content (e.g., no 'document.write' in javascript) and thus, the user agent can continue parsing and rendering."
	self attributes 
		at: 'defer'
		put: true! !

!WAScriptTag methodsFor: 'attributes' stamp: 'jf 2/21/2009 18:29'!
resourceUrl: aString
	self url: (canvas absoluteUrlForResource: aString)! !

!WAScriptTag methodsFor: 'accessing' stamp: 'dwj 6/10/2005 13:10'!
tag
	^ 'script'! !

!WAScriptTag methodsFor: 'attributes' stamp: 'pmm 8/26/2006 00:05'!
url: aString
	self attributes at: 'src' put: aString! !

!WAScriptTag methodsFor: 'public' stamp: 'pmm 6/26/2011 14:22'!
with: aString 
	self attributes 
		at: 'type'
		ifAbsentPut: [ 'text/javascript' ].
	super with: [
		aString isNil ifFalse: [
			self document nextPutAll: aString greaseString ] ]! !

WATagBrush subclass: #WASourceTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WASourceTag commentStamp: 'pmm 7/29/2007 10:46' prior: 0!
The source element allows authors to specify multiple media resources for media elements.

The source attribute must be present. Either the type  attribute, the media attribute or both, must be specified, unless this is the last source element child of the parent element.!

!WASourceTag methodsFor: 'attributes' stamp: 'pmm 7/29/2007 10:50'!
media: aString
	"The media  attribute gives the intended media type of the media resource, to help the user agent determine if this media resource is useful to the user before downloading it. Its value must be a valid media query. [MQ]"
	self attributeAt: 'media' put: aString! !

!WASourceTag methodsFor: 'accessing' stamp: 'pmm 7/29/2007 10:46'!
tag
	^ 'source'! !

!WASourceTag methodsFor: 'attributes' stamp: 'pmm 7/29/2007 10:49'!
type: aString
	"The type  attribute gives the type of the media resource, to help the user agent determine if it can play this media resource before downloading it. Its value must be a MIME type. The codec parameter may be specified and might be necessary to specify exactly how the resource is encoded.
	http://www.faqs.org/rfcs/rfc2046.html
	http://www.faqs.org/rfcs/rfc4281.html"
	self attributeAt: 'type' put: aString! !

!WASourceTag methodsFor: 'attributes' stamp: 'pmm 7/29/2007 10:47'!
url: aString
	"The src attribute gives the address of the media resource. The value must be a URI (or IRI). This attribute must be present."
	self attributeAt: 'src' put: aString! !

WATagBrush subclass: #WATableCellTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:44'!
align: aString
	"This attribute specifies the alignment of data and the justification of text in a cell. Possible values:
	
- left: Left-flush data/Left-justify text. This is the default value for table data.
- center: Center data/Center-justify text. This is the default value for table headers.
- right: Right-flush data/Right-justify text.
- justify: Double-justify text.
- char: Align text around a specific character. If a user agent doesn't support character alignment, behavior in - the presence of this value is unspecified."

	self attributes at: 'align' put: aString! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:45'!
character: aString
	"This attribute specifies a single character within a text fragment to act as an axis for alignment. The default value for this attribute is the decimal point character for the current language as set by the lang attribute. User agents are not required to support this attribute."
	
	self attributes at: 'char' put: aString! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:45'!
characterOffset: anInteger
	"When present, this attribute specifies the offset to the first occurrence of the alignment character on each line. If a line doesn't include the alignment character, it should be horizontally shifted to end at the alignment position."

	self attributes at: 'charoff' put: anInteger! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:44'!
verticalAlign: aString
	"This attribute specifies the vertical position of data within a cell. Possible values:

- top: Cell data is flush with the top of the cell.
- middle: Cell data is centered vertically within the cell. This is the default value.
- bottom: Cell data is flush with the bottom of the cell.
- baseline: All cells in the same row as a cell whose valign attribute has this value should have their textual data positioned so that the first text line occurs on a baseline common to all cells in the row. This constraint does not apply to subsequent text lines in these cells."
		
	self attributes at: 'valign' put: aString! !

WATableCellTag subclass: #WATableColumnGroupTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableColumnGroupTag commentStamp: 'lr 3/24/2008 13:19' prior: 0!
WATableColumnGroupTag groups a set of col elements. It allows you to group several semantically related columns together.!

!WATableColumnGroupTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:37'!
span: anInteger
	"This attribute must be an integer > 0; the default value is 1. This specifies the number of columns in a colgroup, or specifies the number of columns spanned by the col element."
	
	self attributes at: 'span' put: anInteger! !

!WATableColumnGroupTag methodsFor: 'accessing' stamp: 'mb 12/8/2006 15:51'!
tag
	^ 'colgroup'! !

!WATableColumnGroupTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:38'!
width: anInteger
	"The width attribute specifies the width of the columns"
	
	self attributes at: 'width' put: anInteger! !

WATableColumnGroupTag subclass: #WATableColumnTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableColumnTag commentStamp: 'lr 3/24/2008 13:48' prior: 0!
WATableColumnTag elements define the alignment properties for cells in one or more columns.!

!WATableColumnTag methodsFor: 'testing' stamp: 'lr 3/27/2007 11:06'!
isClosed
	^ true! !

!WATableColumnTag methodsFor: 'accessing' stamp: 'mb 12/8/2006 15:51'!
tag
	^ 'col'! !

WATableCellTag subclass: #WATableDataTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableDataTag commentStamp: 'obi 4/2/2008 22:41' prior: 0!
The WATableDataTag defines a cell in a table.

!

!WATableDataTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 17:01'!
abbreviation: aString
	"This attribute should be used to provide an abbreviated form of the cell's content, and may be rendered by user agents when appropriate in place of the cell's content. Abbreviated names should be short since user agents may render them repeatedly. For instance, speech synthesizers may render the abbreviated headers relating to a particular cell before rendering that cell's content."
	
	self attributes at: 'abbr' put: aString! !

!WATableDataTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 17:01'!
axis: aString
	"This attribute may be used to place a cell into conceptual categories that can be considered to form axes in an n-dimensional space. User agents may give users access to these categories (e.g., the user may query the user agent for all cells that belong to certain categories, the user agent may present a table in the form of a table of contents, etc.). Please consult the section on categorizing cells for more information. The value of this attribute is a comma-separated list of category names."
	
	self attributes at: 'axis' put: aString! !

!WATableDataTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:35'!
colSpan: anInteger
	"This attribute specifies the number of columns spanned by the current cell. The default value of this attribute is one. The value zero means that the cell spans all columns from the current column to the last column of the column group (colgroup) in which the cell is defined."
	
	self attributes at: 'colspan' put: anInteger! !

!WATableDataTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:36'!
headers: aString
	"This attribute specifies the list of header cells that provide header information for the current data cell. The value of this attribute is a space-separated list of cell names; those cells must be named by setting their id attribute. Authors generally use the headers attribute to help non-visual user agents render header information about data cells (e.g., header information is spoken prior to the cell data), but the attribute may also be used in conjunction with style sheets. See also the scope attribute."
	
	self attributes at: 'headers' put: aString! !

!WATableDataTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:35'!
rowSpan: anInteger
	"This attribute specifies the number of rows spanned by the current cell. The default value of this attribute is one. The value zero means that the cell spans all rows from the current row to the last row of the current table section (rowgroup) in which the cell is defined. thead, tbody, and tfoot elements are rowgroups."
	
	self attributes at: 'rowspan' put: anInteger! !

!WATableDataTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:35'!
scope: aString
	"This attribute specifies the set of data cells for which the current header cell provides header information. This attribute may be used in place of the headers attribute, particularly for simple tables. When specified, this attribute must have one of the following values:

- row: The current cell provides header information for the rest of the row that contains it (see also the section on table directionality).
- col: The current cell provides header information for the rest of the column that contains it.
- rowgroup: The header cell provides header information for the rest of the row group that contains it.
- colgroup: The header cell provides header information for the rest of the column group that contains it."

	self attributes at: 'scope' put: aString! !

!WATableDataTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 22:09'!
tag
	^ 'td'! !

WATableDataTag subclass: #WATableHeadingTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableHeadingTag commentStamp: 'obi 4/2/2008 22:42' prior: 0!
The WATableHeadingTag defines a table header cell in a table. The text within the th element usually renders in bold.!

!WATableHeadingTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 22:10'!
tag
	^ 'th'! !

WATagBrush subclass: #WATableTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableTag commentStamp: 'obi 4/2/2008 22:42' prior: 0!
The <table> tag defines a table. Inside a <table> tag you can put table headers, table rows, table cells, and other tables.!

!WATableTag methodsFor: 'attributes' stamp: 'lr 12/30/2006 00:11'!
cellpadding: anInteger
	self attributes at: 'cellpadding' put: anInteger! !

!WATableTag methodsFor: 'attributes' stamp: 'lr 12/30/2006 00:11'!
cellspacing: anInteger
	self attributes at: 'cellspacing' put: anInteger! !

!WATableTag methodsFor: 'attributes' stamp: 'pmm 4/8/2007 00:07'!
frame: aString
	"frame = void|above|below|hsides|lhs|rhs|vsides|box|border [CI]
    This attribute specifies which sides of the frame surrounding a table will be visible. Possible values:

        * void: No sides. This is the default value.
        * above: The top side only.
        * below: The bottom side only.
        * hsides: The top and bottom sides only.
        * vsides: The right and left sides only.
        * lhs: The left-hand side only.
        * rhs: The right-hand side only.
        * box: All four sides.
        * border: All four sides."

	self attributes at: 'frame' put: aString! !

!WATableTag methodsFor: 'attributes' stamp: 'pmm 4/8/2007 00:06'!
rules: aString
	"rules = none|groups|rows|cols|all [CI]
    This attribute specifies which rules will appear between cells within a table. The rendering of rules is user agent dependent. Possible values:

        * none: No rules. This is the default value.
        * groups: Rules will appear between row groups (see THEAD, TFOOT, and TBODY) and column groups (see COLGROUP and COL) only.
        * rows: Rules will appear between rows only.
        * cols: Rules will appear between columns only.
        * all: Rules will appear between all rows and columns."
	self attributes at: 'rules' put: aString! !

!WATableTag methodsFor: 'attributes' stamp: 'mb 12/8/2006 15:03'!
summary: aString
	self attributes at: 'summary' put: aString! !

!WATableTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 15:22'!
tag
	^ 'table'! !

!WATagBrush class methodsFor: 'code generation' stamp: 'lr 7/25/2011 19:50'!
tag
	"WASelectTag tag"
	"WAGenericTag tag"

	^ (self selectors includes: #tag)
		ifTrue: [ self new tag ]
		ifFalse: [ nil ]! !

!WATagBrush methodsFor: 'attributes-keyboard' stamp: 'lr 10/28/2007 14:42'!
accessKey: aString
	"Set a keyboard shortcut to access an element. An access key is a single character from the document character set.

	Pressing an access key assigned to an element gives focus to the element. The action that occurs when an element receives focus depends on the element. For example, when a user activates a link defined by the A element, the user agent generally follows the link. When a user activates a radio button, the user agent changes the value of the radio button. When the user activates a text field, it allows input, etc.

The following elements support the accesskey attribute: A, AREA, BUTTON, INPUT, LABEL, and LEGEND, and TEXTAREA.

	The invocation of access keys depends on the underlying system. For instance, on machines running MS Windows, one generally has to press the 'alt' key in addition to the access key. On Apple systems, one generally has to press the 'cmd' key in addition to the access key."

	self attributes at: 'accesskey' put: aString! !

!WATagBrush methodsFor: 'private' stamp: 'lr 4/9/2007 13:18'!
after
	"This template method is called directly after rendering the content of the receiver."! !

!WATagBrush methodsFor: 'accessing-attributes' stamp: 'lr 3/23/2007 20:57'!
attributeAt: aKey
	^ self attributes at: aKey! !

!WATagBrush methodsFor: 'accessing-attributes' stamp: 'lr 3/23/2007 20:58'!
attributeAt: aKey ifAbsent: aBlock
	^ self attributes at: aKey ifAbsent: aBlock! !

!WATagBrush methodsFor: 'accessing-attributes' stamp: 'lr 3/23/2007 20:58'!
attributeAt: aKey ifAbsentPut: aBlock
	^ self attributes at: aKey ifAbsentPut: aBlock! !

!WATagBrush methodsFor: 'accessing-attributes' stamp: 'lr 3/23/2007 20:58'!
attributeAt: aKey ifPresent: aBlock
	^ self attributes at: aKey ifPresent: aBlock! !

!WATagBrush methodsFor: 'accessing-attributes' stamp: 'lr 3/23/2007 20:57'!
attributeAt: aKey put: aValue
	^ self attributes at: aKey put: aValue! !

!WATagBrush methodsFor: 'accessing' stamp: 'lr 3/23/2007 20:08'!
attributes
	^ attributes ifNil: [ attributes := WAHtmlAttributes new ]! !

!WATagBrush methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
attributes: anHtmlAttributes
	attributes := anHtmlAttributes! !

!WATagBrush methodsFor: 'attributes' stamp: 'pmm 3/16/2007 12:05'!
autofocus
	"supported on:
	- Opera 9"
	self attributeAt: 'autofocus' put: true! !

!WATagBrush methodsFor: 'private' stamp: 'lr 4/9/2007 13:18'!
before
	"This template method is called directly before rendering the content of the receiver."! !

!WATagBrush methodsFor: 'attributes-core' stamp: 'lr 10/28/2007 14:42'!
class: aString
	"This attribute assigns one or more class names to an element; the element may be said to belong to these classes. A class name may be shared by several element instances. Multiple classes might be added to one brush."

	self attributes addClass: aString! !

!WATagBrush methodsFor: 'convenience' stamp: 'lr 12/28/2008 11:14'!
class: aString if: aBoolean
	"Adds the class aString to the receiving element if aBoolean is true. 
	
	Example:
	
	html div
		class: 'error' if: self hasError;
		with: self errorMessage"

	aBoolean
		ifTrue: [ self class: aString ]! !

!WATagBrush methodsFor: 'private' stamp: 'lr 12/28/2008 11:16'!
closeTag
	"Close the receiving tag onto the document."

	self document closeTag: self tag! !

!WATagBrush methodsFor: 'attributes-language' stamp: 'lr 10/28/2007 14:42'!
direction: aString
	"Set the text direction ltr (left-to-right) or right-to-left (rtl).

	Not supported on:
	APPLET, BASE, BASEFONT, BR, FRAME, FRAMESET, IFRAME, PARAM, SCRIPT"

	self attributes at: 'dir' put: aString! !

!WATagBrush methodsFor: 'attributes' stamp: 'pmm 5/17/2008 23:21'!
disabled
	"When set for a form control, this boolean attribute disables the control for user input.
When set, the disabled attribute has the following effects on an element:
	-	Disabled controls do not receive focus.
	-	Disabled controls are skipped in tabbing navigation.
	-	Disabled controls cannot be successful (= will not be submitted).
		
	The following elements support the disabled attribute: BUTTON, INPUT, OPTGROUP, OPTION, SELECT, and TEXTAREA. This one other example of functionality implemented way too high in the class hierarchy because we don't have traits."
	self disabled: true! !

!WATagBrush methodsFor: 'attributes' stamp: 'lr 6/6/2007 16:20'!
disabled: aBoolean
	self attributes at: 'disabled' put: aBoolean! !

!WATagBrush methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:39'!
document
	^ canvas document! !

!WATagBrush methodsFor: 'public' stamp: 'lr 4/9/2007 16:31'!
ensureId
	"Answer the id of the receiving attribute. In case the receiver doesn't have an id yet, generate a new one."

	^ self attributes at: 'id' ifAbsentPut: [ canvas nextId ]! !

!WATagBrush methodsFor: 'accessing' stamp: 'pmm 11/21/2007 14:24'!
id
	^ self attributes at: 'id'! !

!WATagBrush methodsFor: 'attributes-core' stamp: 'lr 10/28/2007 14:42'!
id: aString
	"The id attribute assigns a identifier to an element. The id of an element must be unique within a document."

	self attributes at: 'id' put: aString! !

!WATagBrush methodsFor: 'attributes' stamp: 'pmm 7/29/2007 00:30'!
irrelevant
	"All elements may have the irrelevant content attribute set. The irrelevant  attribute is a boolean attribute. When specified on an element, it indicates that the element is not yet, or is no longer, relevant. User agents should not render elements that have the irrelevant  attribute specified."
	self attributeAt: 'irrelevant' put: true! !

!WATagBrush methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
isClosed
	"Answer true if this tag should be closed immediately, such as <br />."

	^ false! !

!WATagBrush methodsFor: 'attributes' stamp: 'lr 7/25/2011 20:10'!
isDisabled
	"answers whether the receiver is disabled"

	^ self attributes at: 'disabled' ifAbsent: [ false ]! !

!WATagBrush methodsFor: 'attributes-language' stamp: 'lr 10/28/2007 14:42'!
language: aString
	"Set the language code."

	self attributes
		at: 'lang' put: aString;
		at: 'xml:lang' put: aString! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'pmm 6/25/2011 20:04'!
onAbort: anObject
	"The abort event occurs when page loading is stopped before an image has been allowed to completely load."

	self document scriptGenerator
		event: 'abort'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 2/21/2010 19:59'!
onBlur: anObject
	"The onblurs event occurs when the element that is in focus, loses that focus."

	self document scriptGenerator
		event: 'blur'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 2/21/2010 19:59'!
onChange: anObject
	"The onchange event occurs when a select input element has a selection made or when a text input element has a change in the text."

	self document scriptGenerator
		event: 'change'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 2/21/2010 19:59'!
onClick: anObject
	"The onclick event occurs when the pointing device button is clicked over an element."

	self document scriptGenerator
		event: 'click'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 2/21/2010 19:59'!
onDoubleClick: anObject
	"The ondblclick event occurs when the pointing device button is double clicked over an element."

	self document scriptGenerator
		event: 'dblclick'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'convenience' stamp: 'pmm 6/25/2011 20:54'!
onError: anObject
	"The error event occurs when an image does not load properly or when an error occurs during script execution."

	self document scriptGenerator
		event: 'error'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 2/21/2010 19:59'!
onFocus: anObject
	"The onfocus event occurs when an element receives focus either by the pointing device or by tabbing navigation."

	self document scriptGenerator
		event: 'focus'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'convenience' stamp: 'lr 2/21/2010 20:00'!
onInput: anObject
	"Any element that accepts an onchange attribute to handle change events shall also accept an oninput  attribute to handle input events, except the output element (for which it would make no sense)."

	self document scriptGenerator
		event: 'input'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 2/21/2010 19:59'!
onKeyDown: anObject
	"The onkeydown event occurs when a key is pressed down over an element."

	self document scriptGenerator
		event: 'keydown'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 2/21/2010 19:59'!
onKeyPress: anObject
	"The onkeypress event occurs when a key is pressed and released over an element."

	self document scriptGenerator
		event: 'keypress'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 2/21/2010 19:59'!
onKeyUp: anObject
	"The onkeyup event occurs when a key is released over an element."

	self document scriptGenerator
		event: 'keyup'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 2/21/2010 19:59'!
onLoad: anObject
	"The onload event occurs when the user agent finishes loading a window."

	self document scriptGenerator
		event: 'load'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 2/21/2010 19:59'!
onMouseDown: anObject
	"The onmousedown event occurs when the pointing device button is pressed over an element."

	self document scriptGenerator
		event: 'mousedown'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 2/21/2010 19:59'!
onMouseMove: anObject
	"The onmousemove event occurs when the pointing device is moved while it is over an element."

	self document scriptGenerator
		event: 'mousemove'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 2/21/2010 19:59'!
onMouseOut: anObject
	"The onmouseout event occurs when the pointing device is moved away from an element."

	self document scriptGenerator
		event: 'mouseout'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 2/21/2010 19:59'!
onMouseOver: anObject
	"The onmouseover event occurs when the pointing device is moved onto an element."

	self document scriptGenerator
		event: 'mouseover'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 2/21/2010 19:59'!
onMouseUp: anObject
	"The onmouseup event occurs when the pointing device button is released over an element."

	self document scriptGenerator
		event: 'mouseup'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 2/21/2010 19:59'!
onReset: anObject
	"The onreset event occurs when a form is reset."

	self document scriptGenerator
		event: 'reset'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'convenience' stamp: 'pmm 6/25/2011 20:54'!
onResize: anObject
	"The resize event occurs when a document view is resized. "

	self document scriptGenerator
		event: 'resize'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'convenience' stamp: 'pmm 6/25/2011 20:54'!
onScroll: anObject
	"The scroll event occurs when a document view is scrolled. "

	self document scriptGenerator
		event: 'scroll'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 2/21/2010 19:59'!
onSelect: anObject
	"The onselect event occurs when a user selects some text in a text field."

	self document scriptGenerator
		event: 'select'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 2/21/2010 19:59'!
onSubmit: anObject
	"The onsubmit event occurs when a form is submitted."

	self document scriptGenerator
		event: 'submit'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 2/21/2010 19:59'!
onUnload: anObject
	"The onunload event occurs when the user agent removes a document from a window."

	self document scriptGenerator
		event: 'unload'
		do: anObject
		on: self! !

!WATagBrush methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
openTag
	"Open the receiving and all associated attributes onto the document."

	self document openTag: self tag attributes: attributes closed: self isClosed! !

!WATagBrush methodsFor: 'attributes' stamp: 'pmm 3/16/2007 12:07'!
required
	"supported on:
	- Opera 9"
	self attributeAt: 'required' put: true! !

!WATagBrush methodsFor: 'private' stamp: 'MAD 2/20/2009 14:50'!
storeCallback: aCallback
	^ canvas callbacks store: aCallback! !

!WATagBrush methodsFor: 'attributes-core' stamp: 'lr 4/9/2007 16:13'!
style: aString
	"This attribute offers optional CSS style information. The attribute is deprecated and should be avoided in favor of an external stylesheet. Multiple styles might be added to one brush."

	self attributes addStyle: aString! !

!WATagBrush methodsFor: 'attributes-keyboard' stamp: 'lr 10/28/2007 14:42'!
tabIndex: aString
	"This attribute specifies the position of the current element in the tabbing order for the current document. This value must be a number between 0 and 32767.

	The tabbing order defines the order in which elements will receive focus when navigated by the user via the keyboard. The tabbing order may include elements nested within other elements.

	The following elements support the tabindex attribute: A, AREA, BUTTON, INPUT, OBJECT, SELECT, and TEXTAREA."

	self attributes at: 'tabindex' put: aString! !

!WATagBrush methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:30'!
tag
	self subclassResponsibility! !

!WATagBrush methodsFor: 'attributes-core' stamp: 'lr 10/28/2007 14:42'!
title: aString
	"This attribute offers advisory information about the element for which it is set. Visual browsers frequently display the title as a 'tool tip'."

	self attributes at: 'title' put: aString! !

!WATagBrush methodsFor: 'public' stamp: 'lr 12/28/2008 11:16'!
with: anObject
	"Render anObject into the receiver. Make sure that you call #with: last in the cascade, as this method will serialize the tag onto the output document."

	self openTag.
	super with: [
		self before.
		canvas render: anObject.
		self after ].
	self isClosed
		ifFalse: [ self closeTag ]! !

!WATagBrush methodsFor: 'convenience' stamp: 'lr 7/25/2011 19:03'!
withLineBreaks: aString
	"Renders text preserving line breaks."

	self with: [ canvas withLineBreaks: aString ]! !

WATagBrush subclass: #WATimeTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATimeTag commentStamp: 'pmm 4/20/2007 01:25' prior: 0!
http://www.whatwg.org/specs/web-apps/current-work/#the-time
not known browser support

The time element represents a date and/or a time.

The datetime attribute, if present, must contain a date or time string that identifies the date or time being specified.

If the datetime attribute is not present, then the date or time must be specified in the content of the element, such that parsing the element's textContent according to the rules for parsing date or time strings in content successfully extracts a date or time. 

see RFC 3339:
http://www.ietf.org/rfc/rfc3339.txt!

!WATimeTag methodsFor: 'attributes' stamp: 'pmm 4/20/2007 01:21'!
datetime: anObject
	"The datetime attribute, if present, must contain a date or time string that identifies the date or time being specified."
	self attributeAt: 'datetime' put: anObject! !

!WATimeTag methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:11'!
tag
	^ 'time'! !

WATagBrush subclass: #WATrackTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATrackTag methodsFor: 'attributes-kind' stamp: 'pmm 9/28/2011 19:22'!
beCaptions
	"Transcription or translation of the dialogue, sound effects, relevant musical cues, and other relevant audio information, suitable for when the soundtrack is unavailable or not clearly audible (e.g. because it is muted, drowned-out by ambient noise, or because the user is deaf). Overlaid on the video; labeled as appropriate for the hard-of-hearing."
	self kind: 'captions'! !

!WATrackTag methodsFor: 'attributes-kind' stamp: 'pmm 9/28/2011 19:24'!
beChapters
	"Chapter titles, intended to be used for navigating the media resource. Displayed as an interactive (potentially nested) list in the user agent's interface."
	self kind: 'chapters'! !

!WATrackTag methodsFor: 'attributes' stamp: 'pmm 9/28/2011 19:30'!
beDefault
	self default: true! !

!WATrackTag methodsFor: 'attributes-kind' stamp: 'pmm 9/28/2011 19:23'!
beDescriptions
	"Textual descriptions of the video component of the media resource, intended for audio synthesis when the visual component is obscured, unavailable, or not usable (e.g. because the user is interacting with the application without a screen while driving, or because the user is blind). Synthesized as audio."
	self kind: 'descriptions'! !

!WATrackTag methodsFor: 'attributes-kind' stamp: 'pmm 9/28/2011 19:26'!
beMetadata
	"Tracks intended for use from script. Not displayed by the user agent."
	self kind: 'metadata'! !

!WATrackTag methodsFor: 'attributes-kind' stamp: 'pmm 9/28/2011 19:22'!
beSubtitles
	"Transcription or translation of the dialogue, suitable for when the sound is available but not understood (e.g. because the user does not understand the language of the media resource's soundtrack). Overlaid on the video."
	self kind: 'subtitles'! !

!WATrackTag methodsFor: 'attributes' stamp: 'pmm 9/28/2011 19:30'!
default: aBoolean
	"The default attribute, if specified, indicates that the track is to be enabled if the user's preferences do not indicate that another track would be more appropriate. There must not be more than one track element with the same parent node with the default attribute specified."
	self attributeAt: 'default' put: aBoolean! !

!WATrackTag methodsFor: 'attributes-kind' stamp: 'pmm 9/28/2011 19:21'!
kind: aString
	"The kind attribute is an enumerated attribute."
	self attributeAt: 'kind' put: aString! !

!WATrackTag methodsFor: 'attributes' stamp: 'pmm 9/28/2011 19:29'!
label: aString
	"The label attribute gives a user-readable title for the track. This title is used by user agents when listing subtitle, caption, and audio description tracks in their user interface."
	self attributeAt: 'label' put: aString! !

!WATrackTag methodsFor: 'attributes' stamp: 'pmm 9/28/2011 19:28'!
sourceLanguage: aString
	"The srclang attribute gives the language of the text track data. The value must be a valid BCP 47 language tag. This attribute must be present if the element's kind attribute is in the subtitles state."
	self attributeAt: 'srclang' put: aString! !

!WATrackTag methodsFor: 'accessing' stamp: 'pmm 9/28/2011 19:19'!
tag
	^ 'track'! !

!WATrackTag methodsFor: 'attributes' stamp: 'pmm 9/28/2011 19:27'!
url: aUrlOrString
	"The src attribute gives the address of the text track data. The value must be a valid non-empty URL potentially surrounded by spaces. This attribute must be present."
	self attributeAt: 'src' put: aUrlOrString! !

WAObject subclass: #WARadioGroup
	instanceVariableNames: 'canvas key values selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WARadioGroup commentStamp: 'pmm 6/1/2008 00:47' prior: 0!
A WARadioGroup is a container for several related radio buttons. It must be used to create radio buttons.

Example:
| group |
group := html radioGroup.
group radioButton
	selected: aBoolean;
	callback: [ self someThing ].
!

!WARadioGroup class methodsFor: 'accessing' stamp: 'ac 7/6/2005 11:30'!
canvas: aRenderCanvas
	^ self basicNew initializeWithCanvas: aRenderCanvas! !

!WARadioGroup methodsFor: 'private' stamp: 'obi 12/30/2009 16:35'!
callback: aBlock
	values := Dictionary new.
	key := canvas callbacks store: (WAValuesCallback on: aBlock values: values)! !

!WARadioGroup methodsFor: 'private' stamp: 'lr 7/25/2011 20:07'!
callbackValue: anObject
	^ self valuesAt: values size + 1 put: anObject! !

!WARadioGroup methodsFor: 'private' stamp: 'lr 7/25/2011 20:08'!
hasCallback
	^ values notNil! !

!WARadioGroup methodsFor: 'testing' stamp: 'obi 12/31/2009 21:49'!
hasSelection
 	^ selected notNil! !

!WARadioGroup methodsFor: 'initialization' stamp: 'TestRunner 1/25/2010 11:04'!
initializeWithCanvas: aRenderCanvas
	self initialize.
	canvas := aRenderCanvas! !

!WARadioGroup methodsFor: 'testing' stamp: 'obi 12/31/2009 21:22'!
isSelected: anObject
	"Test if anObject is currently selected."

 	^ selected = anObject! !

!WARadioGroup methodsFor: 'accessing' stamp: 'TestRunner 1/25/2010 11:04'!
key
	^ key ifNil: [ key := canvas callbacks store: WADispatchCallback new ]! !

!WARadioGroup methodsFor: 'public api' stamp: 'TestRunner 1/25/2010 11:03'!
radioButton
	^ canvas radioButton group: self! !

!WARadioGroup methodsFor: 'accessing' stamp: 'obi 12/31/2009 21:21'!
selected: anObject
	"Set anObject to be selected."

	selected := anObject! !

!WARadioGroup methodsFor: 'private' stamp: 'lr 7/25/2011 20:08'!
valuesAt: aKey put: anObject
	values at: aKey put: anObject.
	^ values size! !

!WARadioGroup methodsFor: 'public api' stamp: 'TestRunner 1/25/2010 11:03'!
with: aBlock
	^ aBlock value: self! !

!WARequestContext methodsFor: '*seaside-canvas' stamp: 'JohanBrichau 9/12/2013 14:06'!
closeThisPopup
	^ self respond: [ :resp |
		resp 
			contentType: WAMimeType textHtml;
			nextPutAll: (WAHtmlCanvas builder
				fullDocument: true;
				rootBlock: [ :root | 
					root title: 'Seaside'; beHtml5 ];
				render: [ :html | html script: 'window.close();' ]) ]! !

!WARequestContext methodsFor: '*seaside-canvas' stamp: 'JohanBrichau 9/12/2013 14:07'!
closeThisPopupAndReloadOpener
	^ self respond: [ :resp |
		resp
			contentType: WAMimeType textHtml;
			nextPutAll: (WAHtmlCanvas builder
				fullDocument: true;
				rootBlock: [ :root | 
					root title: 'Seaside'; beHtml5 ];
				render: [ :html | html script: 'window.close();window.opener.location=window.opener.location;' ]) ]! !
WAHtmlCanvas initialize!
